unit Unit1;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QComCtrls, QExtCtrls, QGrids, QButtons, IniFiles,
  QMask, _math, _String, QCheckLst;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    RadioGroup1: TRadioGroup;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    Label3: TLabel;
    Edit1: TEdit;
    CheckBox1: TCheckBox;
    Edit2: TEdit;
    RadioGroup2: TRadioGroup;
    GroupBox2: TGroupBox;
    SpinEdit4: TSpinEdit;
    Label6: TLabel;
    ComboBox1: TComboBox;
    Label7: TLabel;
    Label8: TLabel;
    TradeByType: TRadioGroup;
    CheckBox2: TCheckBox;
    StringGrid1: TStringGrid;
    Label5: TLabel;
    CheckBox3: TCheckBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    SpinEdit5: TSpinEdit;
    Label10: TLabel;
    ComboBox2: TComboBox;
    Edit3: TEdit;
    SpinEdit3: TSpinEdit;
    Label11: TLabel;
    Label4: TLabel;
    Label12: TLabel;
    BitBtn4: TBitBtn;
    Label13: TLabel;
    Edit5: TEdit;
    TabSheet4: TTabSheet;
    SpinEdit6: TSpinEdit;
    Edit6: TEdit;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    BitBtn5: TBitBtn;
    CheckListBox1: TCheckListBox;
    ComboBox5: TComboBox;
    Label9: TLabel;
    BitBtn6: TBitBtn;
    Edit7: TEdit;
    Label14: TLabel;
    Memo1: TMemo;
    BitBtn7: TBitBtn;
    Label15: TLabel;
    TabSheet5: TTabSheet;
    BitBtn8: TBitBtn;
    GroupBox4: TGroupBox;
    Label16: TLabel;
    ComboBox6: TComboBox;
    Label17: TLabel;
    Edit8: TEdit;
    ComboBox7: TComboBox;
    Label18: TLabel;
    GroupBox5: TGroupBox;
    Label19: TLabel;
    BitBtn9: TBitBtn;
    CheckListBox2: TCheckListBox;
    TabSheet6: TTabSheet;
    Label20: TLabel;
    StringGrid2: TStringGrid;
    Button3: TButton;
    Label22: TLabel;
    BitBtn10: TBitBtn;
    CheckBox5: TCheckBox;
    Label21: TLabel;
    Label23: TLabel;
    SpinEdit7: TSpinEdit;
    Label24: TLabel;
    Label25: TLabel;
    procedure CheckBox1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure TradeByTypeClick(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure TabSheet1Show(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure TabSheet3Show(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure BitBtn5Click(Sender: TObject);
    procedure TabSheet4Show(Sender: TObject);
    procedure ComboBox5Change(Sender: TObject);
    procedure TabSheet2Show(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
    procedure ComboBox6Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure TabSheet5Show(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TabSheet6Show(Sender: TObject);
    procedure StringGrid2SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure Button3Click(Sender: TObject);
    procedure BitBtn10Click(Sender: TObject);
    procedure StringGrid2Exit(Sender: TObject);
    procedure BitBtn9Click(Sender: TObject);

  private
    { Private declarations }
    TradeByTypeLastIndex: Integer;
    BasicSections:TStrings;
    ByValueSections:TStrings;
    LoadTradeByValueTradeSetingsOnce: Boolean;
    ParamStr1:String;
    procedure MakeAddString;
    procedure SwapUgetUgiveVals();
    procedure TickBoxs;
    procedure LoadCheckListBox2;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

constructor TForm1.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);  // Initialize inherited parts
  LoadTradeByValueTradeSetingsOnce := true;
end;

Procedure MakeString;
var
  s: String;
begin
  s := 'Selling '+IntToStr(form1.SpinEdit2.Value)+ ' ' + 'Uncommons';
  if form1.SpinEdit2.Value > 1 then s := s + 's for '
  else s := s + ' for ';
  s := s + IntToStr(form1.SpinEdit1.Value);
  if form1.CheckBox1.checked = true then s := s + ' event ticket';
  form1.Edit2.Text := s;
end;

procedure TForm1.MakeAddString;
var s,UGiveRarity, UGetRarity:string;
begin
  UGiveRarity := ' Uncommons ';
  UGetRarity := LowerCase(' '+RadioGroup1.Items.Strings[RadioGroup1.ItemIndex]);
  if TradeByType.ItemIndex = 0 then
    s := 'Selling ' + IntToStr(SpinEdit2.Value) + UGiveRarity +'for '+ IntToStr(SpinEdit1.Value) + ' Tix'
  else if TradeByType.ItemIndex = 1 then
  begin
    if UGetRarity = ' any' then
    s := 'Buying any ' + IntToStr(SpinEdit1.Value) + ' for '+ IntToStr(SpinEdit2.Value) + ' Tix'
    else
    s := 'Buying ' + IntToStr(SpinEdit1.Value) + UGetRarity +'s for '+ IntToStr(SpinEdit2.Value) + ' Tix'
  end
  else if TradeByType.ItemIndex = 2 then
  begin
    if UGetRarity = ' any' then
    s := 'Trading any ' + IntToStr(SpinEdit2.Value) + ' of my cards for '+ IntToStr(SpinEdit1.Value) + ' of yours'
    else
    s := 'Trading ' + IntToStr(SpinEdit2.Value) +'s of my' + UGetRarity +'s cards for '+ IntToStr(SpinEdit1.Value) + ' of yours'
  end;
  Edit2.text := s;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then
  begin
     RadioGroup1.ItemIndex := 0;
     RadioGroup1.Enabled :=  false;
     TradeByType.ItemIndex := 0;
     //TradeByType.Enabled :=  false;
     Edit1.Text := 'event ticket';
     Edit1.Enabled := False;
     RadioGroup2.ItemIndex := 1;
     RadioGroup2.Enabled :=  false;
     ComboBox1.ItemIndex := 0;
     ComboBox1.Enabled := false;
     SpinEdit4.Value := 0;
     CheckBox2.Checked := false;
     GroupBox2.Enabled := false;
  end
  else begin
     RadioGroup1.Enabled := True;
     RadioGroup1.ItemIndex := 3;
     Edit1.Enabled := False;
     RadioGroup2.Enabled := True;
     TradeByType.Enabled := True;
     TradeByType.ItemIndex := 1;
     Edit1.Text := '';
     Edit1.Enabled := True;
     ComboBox1.Enabled := True;
     SpinEdit4.Value := 4;
     GroupBox2.Enabled := true;
  end;
  MakeString;
end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
{  if RadioButton1.Checked then
    begin
      Edit4.Text := 'common';
      Edit4.Enabled := False;
    end
  else if RadioButton2.Checked then
    begin
      Edit4.Text := 'uncommon';
      Edit4.Enabled := False;
    end
  else if RadioButton3.Checked then
    begin
      Edit4.Text := 'rare';
      Edit4.Enabled := False;
    end
  else if RadioButton5.Checked then
    begin
      Edit4.Text := 'card';
      Edit4.Enabled := False;
    end
  else if RadioButton4.Checked then
    begin
      Edit4.Text := 'commons/uncomons';
      Edit4.Enabled := True;
    end;}
  MakeString;

  end;
procedure TForm1.SwapUgetUgiveVals();
var t: Integer;
begin
  t := SpinEdit1.Value;
  SpinEdit1.Value := SpinEdit2.Value;
  SpinEdit2.Value := t;
end;
procedure TForm1.TradeByTypeClick(Sender: TObject);
begin
  if ((TradeByTypeLastIndex = 0) and (TradeByType.ItemIndex <> 0))
	or ((TradeByTypeLastIndex <> 0) and (TradeByType.ItemIndex = 0)) then SwapUgetUgiveVals;
  TradeByTypeLastIndex := TradeByType.ItemIndex;
  if TradeByType.ItemIndex = 0 then CheckBox1.Checked := True;
  if TradeByType.ItemIndex = 1 then CheckBox3.Checked := True
  else CheckBox3.Checked := False;
//  MakeAddString;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  MakeAddString;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  SwapUgetUgiveVals;
  MakeAddString;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
var
  Ini: TIniFile;
  SecName, s: String;
begin
  SecName := ComboBox2.Text;
  Edit3.Text := SecName;
//  RadioButton4.Checked := true;
//  Edit4.Text := '';
  Ini := TIniFile.Create( GetCurrentDir +'\MBot-TradeSetings.ini' );
  try
    TradeByType.ItemIndex := -1;
    s := LowerCase(Ini.ReadString(secName, 'AddText', 'Selling 1 rare for 6'));
    if  Pos('sell', s) > 0 then TradeByType.ItemIndex := 0
    else if Pos('buy', s) > 0 then
    begin
      CheckBox1.Checked := False;
      TradeByType.ItemIndex := 1
    end
    else begin
      CheckBox1.Checked := False;
      TradeByType.ItemIndex := 2;
    end;
    SpinEdit3.Value := Ini.ReadInteger( secName, 'NumOfTrades', 0);
    SpinEdit2.Value := Ini.ReadInteger( secName, 'UGive', 1);
    SpinEdit1.Value := Ini.ReadInteger( secName, 'UGet', 6);
    RadioGroup1.ItemIndex := RadioGroup1.Items.IndexOf(Ini.ReadString( secName, 'UGetRarity', 'any'));
    RadioGroup2.ItemIndex := RadioGroup2.Items.IndexOf(Ini.ReadString( secName, 'UGetVersion', 'any'));
    ComboBox1.ItemIndex := ComboBox1.Items.IndexOf(Ini.ReadString( secName, 'UGetSet', 'all'));
    Edit1.Text := Ini.ReadString( secName, 'UGetSearch', 'event ticket');
    SpinEdit4.Value := Ini.ReadInteger( secName, 'Max', 1);
    SpinEdit5.Value := Ini.ReadInteger( secName, 'NumberOwned', -1);
    CheckBox3.Checked := Ini.ReadBool( secName, 'GiveOther', False);
    CheckBox5.Checked := Ini.ReadBool( secName, 'Get32First', False);
    Edit2.Text := Ini.ReadString(secName, 'AddText', 'Selling 1 rare for 6');
    Edit2.CursorPos := 1
  finally
    ini.Free;
  end;

end;

procedure TForm1.TabSheet1Show(Sender: TObject);
var
  Ini: TIniFile;
  S:TStrings;
begin
  Ini := TIniFile.Create(GetCurrentDir + '\MBot-TradeSetings.ini' );
  s := TStringList.Create;
  try
    Ini.ReadSections(s);
    ComboBox2.Items := s;
  finally
    Ini.free;
  end;
  Ini := TIniFile.Create(GetCurrentDir + '\MBot-CheckSumFile.ini');
  try
    Edit5.Text := ini.ReadString('Simple trade section to used', 'Section', 'Selling 1 rare for 6');
  finally
    Ini.free;
  end;
  ComboBox1.Items.LoadFromFile(GetCurrentDir + '\Collection tab set menu list.txt');
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
  BitBtn2.Enabled := true;
  BitBtn4.Enabled := true;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
var
  Ini: TIniFile;
begin
  Ini := TIniFile.Create(GetCurrentDir + '\MBot-CheckSumFile.ini');
  try
    ini.WriteString('Simple trade section to used', 'Section', ComboBox2.Text);
  finally
    Ini.free;
  end;
  Ini := TIniFile.Create(GetCurrentDir + '\MBot-CheckSumFile.ini');
  try
    Edit5.Text := ini.ReadString('Simple trade section to used', 'Section', 'Selling 1 rare for 6');
  finally
    Ini.free;
  end;
  BitBtn2Click(Sender);
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  Ini: TIniFile;
  SecName: String;
  S:TStrings;
begin
  SecName := Edit3.Text;
  Ini := TIniFile.Create( GetCurrentDir +'\MBot-TradeSetings.ini' );
  try
    if Ini.SectionExists (SecName) then If MessageDlg('This section already exists. Do you wish to overwrite it?', mtConfirmation, [mbYes, mbNo], 0, mbNo) <> mrYes then Exit;
    Ini.WriteInteger( secName, 'NumOfTrades', SpinEdit3.Value);
    Ini.WriteInteger( secName, 'UGive', SpinEdit2.Value );
    Ini.WriteInteger( secName, 'UGet', SpinEdit1.Value);
    Ini.WriteString( secName, 'UGetRarity', RadioGroup1.Items.Strings[RadioGroup1.ItemIndex]);
    Ini.WriteString( secName, 'UGetVersion', RadioGroup2.Items.Strings[RadioGroup2.ItemIndex]);
    Ini.WriteString( secName, 'UGetSet', ComboBox1.Text);
    Ini.WriteString( secName, 'UGetSearch', Edit1.Text);
    Ini.WriteInteger( secName, 'Max', SpinEdit4.Value);
    Ini.WriteInteger( secName, 'NumberOwned', SpinEdit5.Value);
    if CheckBox3.Checked then Ini.WriteInteger( secName, 'GiveOther', -1)
    else Ini.WriteInteger( secName, 'GiveOther', 0);
    if CheckBox5.Checked then Ini.WriteInteger( secName, 'Get32First', 1)
    else Ini.WriteInteger( secName, 'Get32First', 0);
    Ini.WriteString(secName, 'AddText', Edit2.Text);
  finally
    ini.Free;
  end;
  Ini := TIniFile.Create(GetCurrentDir + '\MBot-TradeSetings.ini' );
  s := TStringList.Create;
  try
    Ini.ReadSections(s);
    ComboBox2.Items := s;
  finally
    Ini.free;
  end;

end;

procedure TForm1.TabSheet3Show(Sender: TObject);
var
  Ini: TIniFile;
  S:TStrings;
  x, Count:Integer;
begin
  count := 1;
  StringGrid1.Cells[0,0] := 'Number';
  StringGrid1.Cells[1,0] := 'Text written by number in chat';
  StringGrid1.Cells[2,0] := 'Trade type';
  StringGrid1.Cells[3,0] := 'Section Name';
  StringGrid1.ColWidths[0] := 50;
  StringGrid1.ColWidths[1] := 400;
  StringGrid1.ColWidths[2] := 60;
  StringGrid1.ColWidths[3] := 230;

  Ini := TIniFile.Create(GetCurrentDir + '\MBot-TradeByValueTradeSetings.ini' );
  s := TStringList.Create;
  try
    Ini.ReadSections(ByValueSections);
  finally
    Ini.free;
    s.Free;
  end;

  Ini := TIniFile.Create(GetCurrentDir + '\MBot-TradeSetings.ini' );
  s := TStringList.Create;
  try
    Ini.ReadSections(BasicSections);
  finally
    Ini.free;
    s.Free;
  end;

  if  ComboBox3.Text = 'Basic' Then ComboBox4.Items := BasicSections
  else ComboBox4.Items := ByValueSections;

  Ini := TIniFile.Create(GetCurrentDir + '\MBot-TradeTypes.ini' );
  s := TStringList.Create;
  try
    Ini.ReadSections(s);
    for x := 0 to s.Count-1 do
      if IsInt(s.Strings[x]) then
      begin
	StringGrid1.RowCount := count + 1;
	StringGrid1.Cells[0,count] := s.Strings[x];
	StringGrid1.Cells[1,count] := Ini.ReadString(s.Strings[x],'Text','Not Set');
	StringGrid1.Cells[2,count] := Ini.ReadString(s.Strings[x],'Type','Not Set');
	StringGrid1.Cells[3,count] := Ini.ReadString(s.Strings[x],'Section','Not Set');
	Inc(count);
      end;
  finally
    ini.Free;
    s.Free;
  end;
  SpinEdit6.Value := StrToInt(StringGrid1.Cells[0,1]);
  Edit6.Text := StringGrid1.Cells[1,1];
  ComboBox3.ItemIndex := ComboBox3.Items.IndexOf(StringGrid1.Cells[2,1]);
  ComboBox4.ItemIndex := ComboBox4.Items.IndexOf(StringGrid1.Cells[3,1]);
end;

procedure TForm1.ComboBox3Change(Sender: TObject);
begin
  if  ComboBox3.ItemIndex = 0 Then ComboBox4.Items := BasicSections
  else ComboBox4.Items := ByValueSections;
  ComboBox4.ItemIndex := -1;
  ComboBox4.ItemIndex := 0;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  BasicSections := TStringList.Create;
  ByValueSections := TStringList.Create;
end;

procedure TForm1.StringGrid1SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
  SpinEdit6.Value := StrToInt(StringGrid1.Cells[0,ARow]);
  Edit6.Text := StringGrid1.Cells[1,ARow];
  ComboBox3.ItemIndex := ComboBox3.Items.IndexOf(StringGrid1.Cells[2,ARow]);
  ComboBox3Change(Sender);
  ComboBox4.ItemIndex := ComboBox4.Items.IndexOf(StringGrid1.Cells[3,ARow]);
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
var
  Ini: TIniFile;
  SecName: String;
  s:TStrings;
  x,count:integer;
begin
  SecName := IntToStr(SpinEdit6.Value);
  Ini := TIniFile.Create( GetCurrentDir +'\MBot-TradeTypes.ini' );
  try
    if Ini.SectionExists (SecName) then If MessageDlg('This section already exists. Do you wish to overwrite it?', mtConfirmation, [mbYes, mbNo], 0, mbNo) <> mrYes then Exit;
    Ini.WriteString( secName, 'Text', Edit6.Text);
    Ini.WriteString( secName, 'Type', ComboBox3.Text);
    Ini.WriteString( secName, 'Section', ComboBox4.Text);
  finally
    ini.Free;
  end;
  Ini := TIniFile.Create(GetCurrentDir + '\MBot-TradeTypes.ini' );
  s := TStringList.Create;
  try
    Ini.ReadSections(s);
    count := 1;
    for x := 0 to s.Count-1 do
      if IsInt(s.Strings[x]) then
      begin
	StringGrid1.RowCount := count + 1;
	StringGrid1.Cells[0,count] := s.Strings[x];
	StringGrid1.Cells[1,count] := Ini.ReadString(s.Strings[x],'Text','Not Set');
	StringGrid1.Cells[2,count] := Ini.ReadString(s.Strings[x],'Type','Not Set');
	StringGrid1.Cells[3,count] := Ini.ReadString(s.Strings[x],'Section','Not Set');
	Inc(count);
      end;
  finally
    ini.Free;
    s.Free;
  end;
end;

procedure TForm1.TickBoxs;
var
  Ini: TIniFile;
  Ss1:TStrings;
  s1,ts:String;
  x,y:Integer;
begin
  for x := 0 to CheckListBox1.Items.Count-1 do
    CheckListBox1.Checked[x] := False;
  Ini := TIniFile.Create(GetCurrentDir + '\MBot-TradeTypes.ini' );
  Ss1 := TStringList.Create;
  try
    s1 := ComboBox5.Text;
    if s1 = '' then s1 := 'Not found';
    s1 := Ini.ReadString('Trade types', s1,'new');
    while InStringC(s1,',') do
    begin
      ts := SplitK3(s1,',');
      ts := DelAllButK(ts, c0To9);
      if ts <> '' then Ss1.Add(ts);
    end;
    Edit7.Text := s1;
    Edit7.CursorPos := 1;
    for x := 0 to Ss1.Count-1 do
      begin
	for y := 0 to CheckListBox1.Items.Count-1 do
	begin
	  s1 := CheckListBox1.Items.Strings[y];
	  ts := CopyTo(s1,':');
	  if Ss1.Strings[x] = ts then
	  begin
	    CheckListBox1.Checked[y] := True;
	    Break;
	  end
	end
      end;
  finally
    ini.Free;
    Ss1.Free;
  end;
end;

procedure TForm1.TabSheet4Show(Sender: TObject);
var
  Ini: TIniFile;
  Ss1, Ss2:TStrings;
  s1:String;
  x:Integer;
begin
  CheckListBox1.Clear;
  Ini := TIniFile.Create(GetCurrentDir + '\MBot-TradeTypes.ini' );
  Ss1 := TStringList.Create;
  Ss2 := TStringList.Create;
  try
    Ini.ReadSections(Ss1);
    for x := 0 to Ss1.Count-1 do
      if IsInt(Ss1.Strings[x]) then
      begin
//	StringGrid1.RowCount := count + 1;
	s1 := Ss1.Strings[x];
	s1 := s1 + ': ' + Ini.ReadString(Ss1.Strings[x],'Text','Not Set');
	s1 := s1 + ', ' + Ini.ReadString(Ss1.Strings[x],'Type','Not Set');
	s1 := s1 + ', ' + Ini.ReadString(Ss1.Strings[x],'Section','Not Set');
	CheckListBox1.Items.Add(s1)
//	Inc(count);
      end;
      Ini.ReadSection('Trade types',Ss2);
      ComboBox5.Items := Ss2;
//      Ini.ReadSection('Accounts',Ss2);
//      ComboBox6.Items := Ss2;
//      ComboBox6.ItemIndex := 0;
//    x := Ini.ReadInteger('Trade types', s1,1);
  finally
    ini.Free;
    Ss1.Free;
    Ss2.Free;
  end;
  ComboBox5.ItemIndex := 0;
  TickBoxs;
end;

procedure TForm1.ComboBox5Change(Sender: TObject);
begin
  TickBoxs;
end;

procedure TForm1.TabSheet2Show(Sender: TObject);
begin
  If LoadTradeByValueTradeSetingsOnce = true then
  begin
    Memo1.Lines.LoadFromFile(GetCurrentDir + '\MBot-TradeByValueTradeSetings.ini');
    Memo1.Modified := False;
    BitBtn7.Enabled := False;
    LoadTradeByValueTradeSetingsOnce := false;
  end;
end;

procedure TForm1.BitBtn7Click(Sender: TObject);
begin
  Memo1.Lines.SaveToFile(GetCurrentDir + '\MBot-TradeByValueTradeSetings.ini');
  Memo1.Modified := False;
  BitBtn7.Enabled := False;
end;

procedure TForm1.Memo1Change(Sender: TObject);
begin
  if Memo1.Modified then BitBtn7.Enabled := true
  else BitBtn7.Enabled := False;
end;

procedure TForm1.BitBtn6Click(Sender: TObject);
var
  s, ts, KeyName:String;
  x:Integer;
  Ini:TIniFile;
begin
  if DelLeading(Edit7.Text,whiteSpace) = '' then
  begin
    ShowMessage('Not saved as add text should not be a empty string.');
    exit;
  end;
  s:='';
  for x := 0 to CheckListBox1.Items.Count -1 do
  begin
    If CheckListBox1.Checked[x] then
    begin
      if s <> '' then s:=s+', ';
      ts := CheckListBox1.Items.Strings[x];
      ts := CopyTo(ts,':');
      s:=s+ts;
    end;
  end;
  s:=s+','+Edit7.Text;
  KeyName := ComboBox5.Text;
  Ini := TIniFile.Create( GetCurrentDir +'\MBot-TradeTypes.ini' );
  try
    if Ini.ValueExists ('Trade types', KeyName) then If MessageDlg('Do you wish to overwrite the settings for this account?', mtConfirmation, [mbYes, mbNo], 0, mbNo) <> mrYes then Exit;
    Ini.WriteString( 'Trade types', KeyName, s);
  finally
    ini.Free;
  end;
  TabSheet4Show(Sender);
end;

procedure TForm1.BitBtn8Click(Sender: TObject);
var
  KeyName:String;
  Ini:TIniFile;
  Ss2:TStrings;
begin
  KeyName := ComboBox6.Text;
  Ini := TIniFile.Create( GetCurrentDir +'\MBot-TradeTypes.ini' );
  Ss2 := TStringList.Create;
  try
    if Ini.ValueExists ('Accounts', KeyName) then
    begin
    //If MessageDlg('Do you wish to overwrite the settings for this account?', mtConfirmation, [mbYes, mbNo], 0, mbNo) <> mrYes then Exit;
      Ini.WriteString( 'Accounts', KeyName, ComboBox7.Text);
      Ini.ReadSection('Accounts',Ss2);
      Ini.WriteInteger('NumOFTrades',KeyName, SpinEdit7.Value);
      ComboBox6.Items := Ss2;
    end
    else begin
      Ini.WriteString( 'Accounts', KeyName, ComboBox7.Text);
      Ini.WriteInteger('NumOFTrades',KeyName, SpinEdit7.Value);
      //$NumOfTrades = Number(IniRead($TradeTypesSettings, 'NumOFTrades', $MagicAccountName, '5'))
      Ini.ReadSection('Accounts',Ss2);
      ComboBox6.Items := Ss2;
    end;
  finally
    ini.Free;
    Ss2.Free;
  end;
  ComboBox6Change(Sender);
  TabSheet5Show(Sender);
end;

procedure TForm1.ComboBox6Change(Sender: TObject);
var
  KeyName:String;
  Ini:TIniFile;
begin
  KeyName := ComboBox6.Text;
  Ini := TIniFile.Create( GetCurrentDir +'\MBot-TradeTypes.ini' );
  try
    if Ini.ValueExists ('Accounts', KeyName) then
    begin
      SpinEdit7.Value := Ini.ReadInteger('NumOFTrades',KeyName, 5);
      Edit8.Text := Ini.ReadString( 'Accounts', KeyName, 'Not set')
    end
    else Edit8.Text := 'Not set';
  finally
    ini.Free;
  end;
end;

procedure TForm1.Edit3Change(Sender: TObject);
begin
  BitBtn1.Enabled := True;
end;

procedure TForm1.TabSheet5Show(Sender: TObject);
var
  Ini: TIniFile;
  Ss2:TStrings;
begin
  Ini := TIniFile.Create(GetCurrentDir + '\MBot-TradeTypes.ini' );
  Ss2 := TStringList.Create;
  try
      Ini.ReadSection('Accounts',Ss2);
      ComboBox6.Items := Ss2;
      ComboBox6.ItemIndex := 0;
      Ini.ReadSection('Trade types',Ss2);
      ComboBox7.Items := Ss2;
      ComboBox7.ItemIndex := 0;
  finally
    ini.Free;
    Ss2.Free;
  end;
  LoadCheckListBox2;
end;

procedure TForm1.LoadCheckListBox2;
var
  Ini: TIniFile;
  Ss2:TStrings;
  s:string;
  i:Integer;
begin
  Ini := TIniFile.Create(GetCurrentDir + '\MBot-TradeTypes.ini' );
  Ss2 := TStringList.Create;
  try
      Ini.ReadSection('Accounts',Ss2);
      CheckListBox2.Clear;
      CheckListBox2.Items := Ss2;
      s := Ini.ReadString('Default Login', 'Account', '');
      i := CheckListBox2.Items.IndexOf(s);
      if i < 0 then exit;
      CheckListBox2.Checked[ i ] := True;
  finally
    ini.Free;
    Ss2.Free;
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  label20.Caption := '';
  If ParamCount >= 1 then
  begin
    ParamStr1 := ParamStr(1);
    label20.Caption := 'Pasword file: '+ParamStr1;
  end;
  TabSheet1.Visible := True;
  TabSheet1Show(Sender);
end;

procedure TForm1.TabSheet6Show(Sender: TObject);
var
  Ini: TIniFile;
  S:TStrings;
  x:Integer;
begin
  StringGrid2.Cells[0,0] := 'Account name';
  StringGrid2.Cells[1,0] := 'Password';
//  StringGrid1.ColWidths[1] := 230;

  Ini := TIniFile.Create(ParamStr1);
  s := TStringList.Create;
  try
    Ini.ReadSection('Login',S);
  except
    Ini.free;
    s.Free;
  end;
  StringGrid2.RowCount := S.Count+2;
  try
    for x := 0 to s.Count-1 do
    begin
      StringGrid2.Cells[0,x+1] := s.Strings[x];
      StringGrid2.Cells[1,x+1] := Ini.ReadString('Login', s.Strings[x],'Not Set');
    end;
  finally
    ini.Free;
    s.Free;
  end;

{  SpinEdit6.Value := StrToInt(StringGrid1.Cells[0,1]);
  Edit6.Text := StringGrid1.Cells[1,1];
  ComboBox3.ItemIndex := ComboBox3.Items.IndexOf(StringGrid1.Cells[2,1]);
  ComboBox4.ItemIndex := ComboBox4.Items.IndexOf(StringGrid1.Cells[3,1]);
 }
end;

procedure TForm1.StringGrid2SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
  if ((ACol = 1) and (ARow > 0)) or (StringGrid2.RowCount -1 = ARow)
  then  StringGrid2.Options := StringGrid2.Options + [goEditing]
//CanSelect {StringGrid2.EditorMode} := true
  else StringGrid2.Options := StringGrid2.Options - [goEditing];
//   {StringGrid2.EditorMode} := false;         set
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  x:Integer;
begin
  if (StringGrid2.Row >= StringGrid2.RowCount - 1) or (StringGrid2.Row < 1) then Exit;
  for x := StringGrid2.Row to StringGrid2.RowCount - 3 do
  begin
    StringGrid2.Rows[x] := StringGrid2.Rows[x + 1];
  end;
  StringGrid2.RowCount := StringGrid2.RowCount - 1;
  StringGrid2.Rows[StringGrid2.RowCount-1].Clear;
end;

procedure TForm1.BitBtn10Click(Sender: TObject);
var
  Ini: TIniFile;
  S:TStrings;
  x, y:Integer;
  Delete:Boolean;
begin
  Ini := TIniFile.Create(ParamStr1);
  s := TStringList.Create;
  try
    Ini.ReadSection('Login',S);
    for x := 1 to s.Count-1 do
    begin
      Delete := True;
      for y := 0 to StringGrid2.RowCount - 2 do
      begin
	if s.Strings[x] = StringGrid2.Cells[0,y]  then
	begin
//	  ShowMessage(+ StringGrid2.Cells[0,x]);
	  Delete := False;
	  Break;
	end;
      end;
      if delete = True then
      begin
	ShowMessage('Deleting key '+ s.Strings[x]);
	ini.DeleteKey('Login', s.Strings[x]);
      end;
    end;
  except
    Ini.free;
    s.Free;
  end;
  try
    for x := 1 to StringGrid2.RowCount - 2 do
    begin
      ini.WriteString('Login',  StringGrid2.Cells[0,x],StringGrid2.Cells[1,x])
    end;
  finally
    ini.Free;
    s.Free;
  end;
end;

procedure TForm1.StringGrid2Exit(Sender: TObject);
begin
  if (StringGrid2.Cells[0,StringGrid2.RowCount-1] <> '')
  then StringGrid2.RowCount := StringGrid2.RowCount + 1
  else begin
    If (StringGrid2.RowCount > 2) and (StringGrid2.Cells[0,StringGrid2.RowCount - 2] = '') and (StringGrid2.Cells[1,StringGrid2.RowCount - 2] = '')
    then StringGrid2.RowCount := StringGrid2.RowCount - 1;
  end

end;

procedure TForm1.BitBtn9Click(Sender: TObject);
var
  x:word;
  s:string;
  Ini: TIniFile;
begin
  for x := 0 to CheckListBox2.Items.Count -1 do
  begin
    If CheckListBox2.Checked[x] then
    begin
      s := CheckListBox2.Items.Strings[x];
      Ini := TIniFile.Create(GetCurrentDir + '\MBot-TradeTypes.ini' );
      try
	Ini.WriteString('Default Login', 'Account',s);
      finally
	ini.Free;
      end;
      LoadCheckListBox2;
      Exit;
    end;
  end;
  LoadCheckListBox2;
end;

end.







