{$A-,B-,D+,E+,F-,G-,I+,L+,N+,O-,R+,S+,V-,X+}
{$M $800,0,0 }   { 2K stack, no heap }
{ This program causes a click each time
 a key is pressed.}
uses Crt, Dos, _Screen, _Num;
var
  KbdIntVec : Procedure;
{$F+}
procedure Keyclick; interrupt;
Const
  key:	Byte = 1;
  y:	Byte = 1;
begin
  key := Port[$60];
  if key < $80 then
    { Only click when key is pressed }
    begin
    Sound(5000);
    Delay(1);
    Nosound;
    end;
   if y > 24 then
    begin
      y := 1;
      ClrScreen(1);
    end;
  DrectWrite(1, y, WordToBin(key));
  Inc(y);
  asm
	PUSHF			{-- Push flags }
	call	KbdIntVec	{ Call old ISR using saved vector }
  end;
end;
{$F-}
begin
  { Insert ISR into keyboard chain }
  GetIntVec($9,@KbdIntVec);
  SetIntVec($9,Addr(Keyclick));
    repeat
    Until ReadKey = 'a';
  SetIntVec($9, @KbdIntVec);
end.


	sub	ax,ax			; Check out keyboard flags
	mov	ds,ax
	mov	al, BYTE PTR ds:[417h]

Check_CA:
	and	al, 0Ch
	cmp	al, 0Ch			; Control and alt?
	jz	CheckDel

	cmp	al, 04h			; Control only?
	jnz	GoVect			; If not, forget it

	in	al, 60h			; Look for control C
	and	al, 7Fh			; Up or down
	cmp	al, 2Eh
	jz	Eat_It			; If so, make it vanish

	cmp	al, 46h			; Look for control break
	jz	Eat_It

	jnz	GoVect			; Otherwise let it pass

CheckDel:
	in      al,60h			; read the key
	and	al,7Fh
	cmp	al,53h			; DEL?
	jnz	GoVect			; if not, forget it

Eat_It:	in	al,61H			; Get value of keyboard control lines
	mov	ah,al			; Save it
	or	al,80h			; Set the "enable kbd" bit
	out	61H,al			;  and write it out the control port
	xchg	ah,al			; Fetch original control port value
	out	61H,al			;  and write it back
	mov	al,20H			; Send End-Of-Interrupt signal
	out	20H,al			;  to the 8259 Interrupt Controller

	mov	ax, WORD PTR cs:[TempD]
	mov	ds,ax
	mov	ax, WORD PTR cs:[TempA]
	iret

