{$A-,B-,D+,E+,F-,G-,I+,L+,N+,O-,R+,S+,V-,X-}
{$M 16384,0,655360}
Unit _Help;

interface

Uses crt, Dos, _String, _Buffers, _Error, _KeyB, _Dos, _Win2, _Screen,
     _Menus, _JWord, _HyperText;

Const
  HelpTopic : string = '';
  HelpFile:	ComStr = 'Help.Hlp';
  allowHelpIntr: Boolean = True;

Procedure Help;


Implementation
var
  Buf:	BufferO;

Function FindHelp(s: String):Word;
var
  x: Word;
  s2: String;
begin
  FindHelp := 0;
   for x := 1 to buf.Len do
    begin
      s2 := buf.Get(x);
       if InStringPos(s2, '@') = 1 then
	begin
	  s2 := DelFirst(s2, 1);
	   if s = s2 then
	    begin
	      FindHelp := x;
	      exit;
	    end;
	end
    end;
end;

Procedure ViewHelp(p: Word);
var
  List:	ListBufO;
  s:	String;
  WindId, x:	Word;
  buf2:	BufferO;
begin
  buf2.init;
  x := p;
   While x <= buf.Len do
    begin
      s := buf.Get(x);
       if (InStringPos(s, '@') <> 1) or (p = x) then buf2.Add(s)
       else x := buf.len;
      Inc(x);
    end;
  list.Init;
  WindId := MakeWindow(0, 2, 70, 15, 0, 'Help window');
  s := list.ListBuffer(buf2, False);
  buf2.Done;
  DelWindow(0,0);
end;


Procedure Help;
Const
  helpDepth: Word = 0;
var
  helpBufPos, error:	Word;
begin
  allowHelpIntr := False;
  Inc(helpDepth);
  Flush;
   if helpDepth = 1 then error := LoadBuffer(buf, HelpFile);
   if HelpTopic = '' then
    begin
       if helpDepth > 1 then
	begin
	  allowHelpIntr := False;
	  ViewHelp(1);
	end
	else begin
	  allowHelpIntr := True;
	  Message('Information press any key',
		  'Sorry no help available at this point'#10+
		  'Press "F1" again for main help screen', False, 1, 0, 0);
	end;
    end
    else begin
      helpBufPos := FindHelp(HelpTopic);
       if helpBufPos < 1 then
	begin
	  allowHelpIntr := True;
	  Message('Information press any key',
		  'Sorry can not find key word: <'+HelpTopic+'> (error in help file?)'#10+
		  'Press "F1" again for main help screen', False, 1, 0, 0);
	end
       else begin
	 ViewHelp(helpBufPos);
       end;
    end;
  Dec(helpDepth);
   if helpDepth < 1 then
    begin
      buf.Done;
    end;
  allowHelpIntr := True;
end;
Begin
  buf.Init;
END.
