unit _HyperText;

Interface

uses dos, _Buffers, _Dos, _String, _KeyB;

type
  HyperTextO = Object
		 JumpToFileAlowed:	Boolean;

		 Constructor Init;
		 Destructor Done;

		 Procedure View;

		 Function Install(HyperFile: ComStr):	Boolean; Virtual;
	       Private
		 buf, buf2, buf3:				BufferO;
		 Xc, Yc:					Word;
		 fileName:					ComStr;
		 LinePos, ScreenPos, LineShift:	Integer;
		 Shift, bufShiftPos, oldFilePos:		Word;
		 oldLineShift:					Byte;
		 i, upD, saved:					Boolean;
		 Procedure Decode;
	       end;


Implementation

Constructor HyperTextO.Init;
begin
  buf.Init;
  buf2.Init;
  buf3.Init;
  Xc             := 1 ;
  Yc             := 1 ;
  fileName	:= '';
  linePos	:= 1 ;
  screenPos	:= 1 ;
  lineShift	:= 0 ;
  bufShiftPos	:= 0 ;
end;

Destructor HyperTextO.Done;
begin
  buf.Done;
  buf2.Done;
  buf3.Done;
  Xc             := 1 ;
  Yc             := 1 ;
  fileName	:= '';
  linePos	:= 1 ;
  screenPos	:= 1 ;
  lineShift	:= 0 ;
  bufShiftPos	:= 0 ;
end;

Procedure HyperTextO.View;
var
  k	:Key;
begin
    repeat
       if k = up then
	begin
	end
       else if k = Down then
	begin
	end
       else if k = PgUp then
	begin
	end
       else if k = PgDn then
	begin
	end
       else if k = home then
	begin
	end
       else if k = end1 then
	begin
	end
       else if k = CPgUp then
	begin
	end
       else if k = CPgDn then
	begin
	end
       else if k = Tab then
	begin
	end
       else if k = Enter then
	begin
	end
    until k = Esc;
end;

Function HyperTextO.Install;
var OldDir : DirStr;
Begin
  Install := True;
  OldDir := CToFileDir(FileName);
  Init;
  saved := True;
   if loadbuffer(buf, FileName) = 0 then
    begin
      FileName := HyperFile;
      Decode;
    end
    else begin
      ChDir(OldDir);
      Install := False;
    end;
end;

Procedure HyperTextO.Decode;
var
  buf4:			BufferO;
  s, s2, code, l:	String;
  x:			Word;
begin
   for x := 1 to buf.Len do
    begin
      s := buf.Get(x);
       While InString(s, '<') and (InStringPos(s, '<') < inStringPos(s, '>') ) do
	begin
	  s2 := SplitK(s, '<');
	  Code := SplitK2(s, '>');
	  Code := DelAllK(code, '<>:;');
	   if Length(code) < 1 then x:=x
	   else if SupCase(code) = 'END' then buf3.Add(IntToStr(x))
	   else if code[1] = '@' then
	    begin
	      l := code + ':' + IntToStr(x);
	      buf4.add(l);
	    end
	   else if buf.Len = x then
	    begin
	      l := buf2.get(x) + ';' + code;
	      buf2.Ovr(l, x);
	    end
	   else buf2.Ovr(code, x);
	end;
    end;
end;


BEGIN

END.