unit _my;

interface

type list = array [1..10] of string;

function fileexists(s:string):boolean;

function chop(var st:string):string;

function rest(s:string):string;

function caps(s:string):string;

function wurd(s:string;i:integer):string;

function LeadingZero(w : Word) : String;

function spaces(n:integer):string;

function rpad(s:string; n:integer):string;

function lpad(s:string; n:integer):string;

function unpack(t:longint):string;

function sdrive(s:string):string;

Procedure ryed(b:list;high,width:integer);

Procedure shift(var b:list);

function trunk(s:string;i:integer):string;

{function keycode:string;}

implementation

uses dos,crt;

function fileexists(s:string):boolean;
  var f:file;
begin
  assign(f,s);
  {$I-}
  reset(f);
  close(f);
  {$I+}
  fileexists := (IOResult = 0) and (s <> '');
end;

function chop(var st:string):string;
  var s,e,i:integer;
begin
  i:=1;
  s:=0;
  e:=0;
  while (i <= length(st)) and (st[i] = ' ') do
    i:=i+1;                                 { get rid of leading spaces }
  s := i;
  while (i <= length(st)) and (st[i] <> ' ') do
    i := i + 1;                                 { get rid of word }
  e := i;
  while (i <= length(st)) and (st[i] = ' ') do
    i := i + 1;                                 { get rid of trailing spaces }
  if (s > 0) and (e > 0) then
    begin
      chop := copy(st,s,e-1);
      st := copy(st,i,length(st));
    end
  else chop:='';
end;

function rest(s:string):string;
  var dum:string;
begin
  dum:=chop(s);
  rest:=s;
end;

function caps(s:string):string;
  var i:integer;
      ans:string;
begin
  ans:='';
  if s='' then ans:=''
    else
      for i:=1 to length(s) do
        ans:=ans+upcase(s[i]);
  caps:=ans;
end;

Function wurd(s:string;i:integer):string;
  var ans:string;
      n:integer;
begin
  n:=1;
  ans:=chop(s);
  while (ans <> '') and (n<i) do
    begin
      ans:=chop(s);
      n:=n+1;
    end;
  wurd:=ans;
end;

function LeadingZero(w : Word) : String;
var
  s : String;
begin
  Str(w:0,s);
  if Length(s) = 1 then
    s := '0' + s;
  LeadingZero := s;
end;

function spaces(n:integer):string;
  var i:integer;
      ans:string;
begin
  ans:='';
  for i:=1 to n do
    ans:=ans+' ';
  spaces:=ans;
end;

function rpad(s:string; n:integer):string;
begin
  if length(s)<n then
    rpad:=concat(spaces(n-length(s)),s)
  else rpad:=s;
end;

function lpad(s:string; n:integer):string;
begin
  if length(s)<n then
    lpad:=concat(s,spaces(n-length(s)))
  else lpad:=s;
end;

function unpack(t:longint):string;
{DateTime = record
  Year,Month,Day,Hour,
  Min,Sec: Word;
end;}
  var dt:datetime;
begin
  unpacktime(t,dt);
  with dt do
    begin
      unpack:=concat(LeadingZero(Day),'-', LeadingZero(Month), '-',
		     LeadingZero(Year), ' ',
		     LeadingZero(hour),':',LeadingZero(min));
    end;
end;

function trunk(s:string;i:integer):string;
begin
  if length(s)>i
    then
      trunk:=copy(s,1,i)
    else
      trunk:=s;
end;

function sdrive(s:string):string;
 var fstw:string;
begin
  fstw:=wurd(s,1);
  if (length(fstw) > 1) and (fstw[1] in ['A','B','C','D','E']) and (fstw[2]=':') then
    sdrive:=copy(fstw,1,2)
  else
    sdrive:='';
end;

Procedure ryed(b:list;high,width:integer);
  var i:integer;
  begin
    for i := 10 downto 1 do
      begin
        if i=high then
          begin
            textcolor(black);
            textbackground(white);
          end;
        writeln(trunk(b[i],width));
        if i=high then
          begin
            textcolor(white);
            textbackground(black);
          end;
      end;
  end;

Procedure shift(var b:list);
  var i:integer;
  begin
    for i := 1 to 9 do
      begin
        b[i] := b[(i + 1)]
      end;
    b[10]:='';
  end;

function keycode:string;
  var ans:string[2];
begin
  ans:=readkey;
  if ans[1] = #0 then ans := ans + readkey;
  keycode := ans;
end;

end.