unit Dice1;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QButtons;

type
  TForm1 = class(TForm)
    ComboBox1: TComboBox;
    Label1: TLabel;
    ComboBox2: TComboBox;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    ListBox1: TListBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    BitBtn2: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
Uses _math;

{$R *.xfm}

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  x,t:word;
  s,lowest, total, sides:String;
  debug:Boolean;
begin
  debug := False;
  t := StrToInt(form1.ComboBox1.Text);
  sides := form1.ComboBox2.Text;
  lowest := sides;
  if CheckBox1.Checked then ListBox1.Items.Clear;
  ListBox1.Items.Add('New roll');
  total := '';
  for x := 1 to t do
  begin
    s := RandBetween('1',sides);
    if debug then s := '9';
    total := AddInt(total,s);
    if CheckBox2.Checked and IsGreater(lowest, s) then lowest := s;
    ListBox1.Items.Add('   roll '+intToStr(x)+' = '+s);
  end;
  if CheckBox2.Checked then
  begin
    ListBox1.Items.Add('   The lowest dice is: '+lowest);
    ListBox1.Items.Add('   The total less the lowest is: '+SubInt(total,lowest));
  end
  else ListBox1.Items.Add('   The total is: '+total);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  ListBox1.Items.Clear;
end;

end.
