unit _PlaySound;

interface

uses
  Classes;

type
  PlaySoundO = class(TThread)
  private
    { Private declarations }
  protected
    procedure Execute; override;
  end;

implementation

{ Important: Methods and properties of objects in VCL can only be used in a
  method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure PlaySoundO.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ PlaySoundO }

procedure PlaySoundO.Execute;
begin
  { Place thread code here }
end;

end.
