unit _ScoreUtills2;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, Grids, DBGrids, IBDatabase, IBTable, IBCustomDataSet, IBQuery,
  _Buffers, _String, _score;

type
  TFrame1 = class(TFrame)
    IBTransaction1: TIBTransaction;
    IBTable1: TIBTable;
    IBDatabase1: TIBDatabase;
    DataSource1: TDataSource;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  su:TFrame1;

procedure loadBufFromScoreDB(f: String);

implementation
{$R *.DFM}


procedure loadBufFromScoreDB(f: String);
//f should be subdir + file
var
  buf:BufferO;
  percentS, nameS, dateS, timeS, maxHelpS, totalS, scoreS, s1:string;
  totalN, percent:integer;
begin
  buf.Init;
  su.IBTable1.Filter := 'file1 := name';//'UPPER(file1) = '#39+SUpCase(f)+#39;
   if su.IBTable1.FindFirst then
    repeat
//      := su.IBTable1.FieldByName('help_total');
//      su.IBTable1.FieldByName('file1');
      nameS := su.IBTable1.FieldByName('name').AsString;
      dateS := su.IBTable1.FieldByName('date1').AsString;
      timeS := su.IBTable1.FieldByName('time').AsString;
      maxHelpS := IntToStr(su.IBTable1.FieldByName('max_help').AsInteger);
      totalS:= IntToStr(su.IBTable1.FieldByName('word_count').AsInteger);
      scoreS:= IntToStr(su.IBTable1.FieldByName('score').AsInteger);
      totalN := StrToNum(totalS);
       if totalN = 0 then totalN := 1;
      percent := round((100 / totalN) * StrToNum(scoreS));
      nameS := PadTo(nameS, #133, 51);
       if dateS <> '' then dateS := ' on the ' + dateS;
      dateS := PadTo(dateS, #46, 18);
       if timeS <> '' then timeS := '@'+timeS;
      maxHelpS := ' '+PadTo(maxHelpS, ' ', 3)+' ';
      timeS := PadTo(timeS, #46, 9);
      percentS := PadFront(IntToStr(percent),'0',3);
      scoreS := PadFront(scoreS,' ',3);
      totalS := PadTo(totalS,' ',3);
      s1 := nameS+'%'+percentS+' or '+scoreS+'/'+totalS+
	    dateS+timeS;
      buf.add(s1);
    until not su.IBTable1.FindNext;
//  ShowScore(buf);
  buf.Done;
end;

end.
