unit _Script;

interface
uses _String,_Math, SysUtils;

const
  RandomizeExpand:	Boolean = False;
  ScriptOverride:       Boolean = False;

Function IsSwitch(s:String):Boolean ;
Function UpdateSwitch(s:String):Boolean ;

implementation

Function IsSwitch(s:String):Boolean ;
begin
  result := CompTo(s, '$RandomizeExpandOn',18)
    or CompTo(s, '$RandomizeExpandOff',19)
    or CompTo(s, '$script',7)
    or CompTo(s, '$scriptOff',10)
    or CompTo(s, '$Decimal points',15)
    or CompTo(s, '$noSort',7);	//this is dealt with in main2 etc, as it is a global switch
end;


Function UpdateSwitch(s:String):Boolean ;
begin
  result := True;
  if CompTo(s, '$RandomizeExpandOn',18) then RandomizeExpand := True
  else if CompTo(s, '$RandomizeExpandOff',19) then RandomizeExpand := False
  else if CompTo(s,'$script',7) then ScriptOverride := True
  else if CompTo(s,'$scriptOff',10) then ScriptOverride := False
  else if CompTo(s, '$noSort',7) then	//this is dealt with in main2 etc, as it is a global switch
  else if CompTo(s,'$Decimal points',15) then
  begin
    s := DelFirst(s,15);
    s := delAllButK(s,c0To9);
    s := TruncateTo(s,2);
    if StrToInt(s) <= 18 then decimalPoints := StrToInt(s)
    else decimalPoints := 18;
  end
  else result := False;
end;

end.
