{$A-,B-,D-,E+,F-,G-,I+,L+,N+,O-,R+,S+,V-,X-}
Unit _Code;

interface
type
  S80 = String;

Function ErrorCode(in1 : Word): S80;
Function UnitCode(in1 : Word): S80;

implementation
uses
  SysUtils;

Function UnitCode(in1 : Word): S80;
Const
  out1 : S80 = '';
begin
  case in1 of
    0 :   out1 := 'Error in main program';
    1  :  out1 := 'Error in unit 1 "_Buffers"';
    2  :  out1 := 'Error in unit 2 "_Code"';
    3  :  out1 := 'Error in unit 3 "_Crypt"';
    4  :  out1 := 'Error in unit 4 "_Dos"';
    5  :  out1 := 'Error in unit 5 "_EditLine"';
    6  :  out1 := 'Error in unit 6 "_Error"';
    7  :  out1 := 'Error in unit 7 "_ExitData"';
    8  :  out1 := 'Error in unit 8 "_ExitProc"';
    9  :  out1 := 'Error in unit 9 "_Jdos"';
    10 :  out1 := 'Error in unit 10 "_JWord"';
    11 :  out1 := 'Error in unit 11 "_KeyB"';
    12 :  out1 := 'Error in unit 12 "_LString"';
    13 :  out1 := 'Error in unit 13 "_Menus"';
    14 :  out1 := 'Error in unit 14 "_My"';
    15 :  out1 := 'Error in unit 15 "_Num"';
    16 :  out1 := 'Error in unit 16 "_PasWord"';
    17 :  out1 := 'Error in unit 17 "_Prin"';
    18 :  out1 := 'Error in unit 18 "_Screen"';
    19 :  out1 := 'Error in unit 19 "_String"';
    20 :  out1 := 'Error in unit 20 "_Wind2"';

    else out1 := 'Unknown error'
  end;
  UnitCode := out1
end;


Function ErrorCode(in1 : Word): S80;
Const
  out1 : S80 = '';
begin
  case in1 of
    1 :   out1 := 'Invalid function number';
    2 :   out1 := 'File not found';
    3 :   out1 := 'Path not found';
    4 :   out1 := 'Too many open files';
    5 :   out1 := 'Access denied';
    6 :   out1 := 'Invalid handle';
    8 :   out1 := 'Not enough memory';
    10 :  out1 := 'Invalid environment';
    11 :  out1 := 'Invalid format';
    12 :  out1 := 'Invalid file access code';
    15 :  out1 := 'Invalid drive number';
    16 :  out1 := 'Cannot remove current directory';
    17 :  out1 := 'Cannot rename across drives';
    18 :  out1 := 'No more files';

    100 : out1 := 'Disk read error';
    101 : out1 := 'Disk write error';
    102 : out1 := 'File not assigned';
    103 : out1 := 'File not open';
    104 : out1 := 'File not open for input';
    105 : out1 := 'File not open for output';
    106 : out1 := 'Invalid numeric format';

    150 : out1 := 'Disk is write-protected';
    151 : out1 := 'Bad drive request struct length or unknown unit';
    152 : out1 := 'Drive not ready';
    153 : out1 := 'Unknown command';
    154 : out1 := 'CRC error in data';
    156 : out1 := 'Disk seek error';
    157 : out1 := 'Unknown media type';
    158 : out1 := 'Sector Not Found';
    159 : out1 := 'Printer out of paper';
    160 : out1 := 'Device write fault';
    161 : out1 := 'Device read fault';
    162 : out1 := 'Hardware failure';
    200 : out1 := 'Division by zero';
    201 : out1 := 'Range check error';
    202 : out1 := 'Stack overflow error';
    203 : out1 := 'Heap overflow error';
    204 : out1 := 'Invalid pointer operation';
    205 : out1 := 'Floating point overflow';
    206 : out1 := 'Floating point underflow';
    207 : out1 := 'Invalid floating point operation';
    208 : out1 := 'Overlay manager not installed';
    209 : out1 := 'Overlay file read error';
    210 : out1 := 'Object not initialized';
    211 : out1 := 'Call to abstract method';
    212 : out1 := 'Stream registration error';
    213 : out1 := 'Collection index out of range';
    214 : out1 := 'Collection overflow error';
{*********************************User Error*********************}
    500	: out1 := 'x coordinate to low';
    501	: out1 := 'x coordinate to high';
    502	: out1 := 'Range check error (page to low)';
    503	: out1 := 'Range check error (page to high)';
    504 : out1 := 'y coordinate to low';
    505 : out1 := 'y coordinate to high';
    506 : out1 := 'x, y coordinate out of range';
    507 : out1 := 'Trying to make ((y - 1) * screen width) + x = < 1';

    510 : out1 := 'Pointer initialized';
    511 : out1 := 'Pointer not initialized';

    520 : out1 := 'Not enough heap memory for Getmem operation';
    521 : out1 := 'Trying to Free a nil pointer';
    522 : out1 := 'Buffer can''t exceed 65535(a word) lines';
    523 : out1 := 'Trying to access a buffer element that is a nonentity';
    524 : out1 := 'Trying to access a buffer element that is a nonentity < 0';

    530 : out1 := 'Window not big enough';
    531 : out1 := 'Window not wide enough';
    532 : out1 := 'Window not deep enough';
    533 : out1 := 'Page not big enough';
    534 : out1 := 'Page not wide enough';
    535 : out1 := 'Page not deep enough';
    536 : out1 := 'Trying to create a window with right side off Page';
    537 : out1 := 'Trying to create a window with left side off Page';
    538 : out1 := 'Trying to create a window with top side off Page';
    539 : out1 := 'Trying to create a window with bottom side off Page';
    540 : out1 := 'Trying to access a page that is a nonentity';
    541 : out1 := 'Trying to access a window that is a nonentity';
    542 : out1 := 'Width * depth > than saved screen size';
    543 : out1 := 'Trying to create a window with a width of < 0';
    544 : out1 := 'Trying to create a window with a depth of < 0';

    560 : out1 := 'Trying to access an environment variable that is out of Range';
    561 : out1 := 'Out of environment variable memory.';
    562 : out1 := 'Trying to access the environment''''s Program Name of the first PSP';

    570 : out1 := 'Incomplete menu structure';
    571 : out1 := 'Error in menu format';
    572 : out1 := 'Menu file not found';

    590 : out1 := 'Pasword file not found';
    591 : out1 := 'User name all ready exist';

    600 : out1 := 'String value of '''' not acceptable.';
    601 : out1 := 'Error making dir.';
    700 : out1 := 'Start up file error';

    800 : out1 := 'No database found'
    else out1 := 'Unknown error'
  end;
  ErrorCode := 'Error num '+IntToStr(in1)+', '+out1
end;

end.