{$A+,B-,D+,E+,F+,I+,L+,N-,O+,R+,S+,V+,X+}
Unit _JDOS;

Interface

uses dos, _Buffers;
Type
  S12 = String[12];
  S1  = String[1];
Const
  JmcDir  : DirStr    = '';
  DosEC   : Word = 0;
type
  GetFileO = Object
	       Procedure Init;
	       Procedure Done;

	       Procedure ReadDir;
	       Procedure SetDir(startDir1, dir1 : DirStr);
	       Procedure SetWriteable(b: Boolean);
	       Function  GetFile: ComStr;

	     Private
	       Buf 		: BufferO;
	       dir, startDir	: DirStr;
	       startString	: String;
	       pos		: Word;
	       writeable	: Boolean;
	       Function SubDir: DirStr;
	       
	     end;

  GetDirO  = Object
	       Procedure Init;
	       Procedure Done;
{	       Procedure ReadDir;}
	       Procedure SetDir(startDir1, dir1 : DirStr);
	       Function  GetDir: ComStr;
	     Private
               
	       Buf 		: BufferO;
	       dir, startDir	: DirStr;
	       startString	: String;
	       pos		: Word;
{               Function SubDir:DirStr;}
	     end;


Procedure DelFile(f :String);
Procedure Open(f : ComStr);
Procedure CreateFile(f: Comstr);
Function TFile(s : ComStr) : Boolean;
Function TOpen(f : String): Boolean;
Function TestFile(s : ComStr): ComStr; { find a file }
Function ParamFile : ComStr;

Function FileDrive(s : ComStr) : S1;
Function GetFileDir(s : String) : DirStr; {Prams must be removed}
Function GetFileExt(s : String) : ExtStr; {Prams must be removed}
Function GetFileName(s : String) : NameStr; {Prams must be removed}

Procedure JExec(in1, in2 : String);
Procedure ChDir(S : String);
Procedure WriteTime(x, y : Byte);
Function GetFile(start : string) : ComStr;
Function GetFileDirNameExt(s : String): String;

Function Vol(s : String) : S12;

Implementation

uses _String, {Windows,} crt, _Error, _Dos, _win2, _keyB, _EditLine,
     _Screen, _My, _JWord;

{*****************************begin GetFileO*************************}
Procedure GetFileO.Init;
begin
  buf.Init;
  writeable := False;
  startString := '';
  dir := '*.*';
  startDir := '\';
  pos := 1;
end;

Procedure GetFileO.Done;
begin
  buf.Clr;
  pos := 1;
  dir := '*.*';
  startString := '';
end;

Procedure GetFileO.ReadDir;
var
  t : String;
  x : Byte;
begin
  t := '';
   for x := Ord('!') to Ord('z') do t := t+Char(x);
  dir := GetInPutWin(10, 5, 79, dir, t);
end;


Function GetFileO.GetFile: ComStr;
var
  DirInfo	:SearchRec;
  list		:ListBufO;
  temp, temp2	:DirStr;
begin
  temp2 := FileNameExt(dir);
  dir := FileDir(dir);
  GetFile := '';
   If ErrorCheck then InOutZ;
    repeat
      buf.Clr;
       if subDir <> '' then buf.Add('' {#24});
      FindFirst(startDir+dir+temp2, Directory, DirInfo);
       while DosError = 0 do
	begin
	   if (DirInfo.Attr and Directory) = Directory then
	    buf.Add(''{#25} + DirInfo.Name);
	  FindNext(DirInfo);
	end;
       if writeable then buf.Add('*newfile');
      FindFirst(startDir+dir+temp2, Archive, DirInfo);
       while DosError = 0 do
	begin
	  buf.Add(DirInfo.Name);
	  FindNext(DirInfo);
	end;
       buf.Sort;
       if (WindDepth(0,0) < 1) or (WindWidth(0,0) < 1) then
	begin
	  if ErrorCheck then InOut(530, 9, 97);
	end else
      list.Init;
      temp := list.ListBuffer(buf, False);
       if temp <> '' then GetFile := dir + temp
       else GetFile := '';
      list.Done;
       if length(temp) > 0 then
	begin
	   if temp[1] = #24 then
	    begin
	      dir := DelLast(dir, 1);
	      dir := TruncateTo(dir, FindLastC(dir, '\'));
	    end
	   else if temp[1] = #25 then
	    begin
	      dir := dir + DelFirst(temp, 1) +'\';
	    end;
	end;
    until (temp[1] <> #25) and (temp[1] <> #24);
  dir := dir + temp2;
end;

Procedure GetFileO.SetDir(startDir1, dir1 : DirStr);
begin
  dir := dir1;
  startDir := startDir1
end;

Procedure GetFileO.SetWriteable(b: Boolean);
begin
  writeable := b;
end;

Function GetFileO.SubDir: DirStr;
begin
  SubDir := dir;
end;
{*****************************end GetFileO*************************}

{*****************************begin GetDirO*************************}
Procedure GetDirO.Init;
begin
  buf.Init;
  startString := '';
  dir := '*.*';
  startDir := '\';
  pos := 1;
end;

Procedure GetDirO.Done;
begin
  buf.Clr;
  pos := 1;
  dir := '*.*';
  startDir := '\';
  startString := '';
end;

Function GetDirO.GetDir: ComStr;
var
  DirInfo	:SearchRec;
  list		:ListBufO;
  temp, temp2	:DirStr;
  oldDir, oldStartDir	:ComStr;
begin
  oldDir := dir;
  oldStartDir := startDir;
  temp := '';
  temp2 := FileNameExt(dir);
  dir := FileDir(dir);
  GetDir := '';
   If ErrorCheck then InOutZ;
    repeat
      buf.Clr;
       if dir <> '' then buf.Add('' {#24});
      FindFirst(startDir+dir+temp2, Directory, DirInfo);
       while DosError = 0 do
	begin
	   if (DirInfo.Attr and Directory) = Directory then
	    buf.Add(''{#25} + DirInfo.Name);
	  FindNext(DirInfo);
	end;
       buf.Sort;
       if (WindDepth(0,0) < 1) or (WindWidth(0,0) < 1) then
	begin
	  if ErrorCheck then InOut(530, 9, 97);
	end else
      list.Init;
      temp := list.ListBuffer(buf, False);
       if temp <> '' then GetDir := dir + temp
       else GetDir := '';
      list.Done;
       if (length(temp) > 0)then
	begin
	   if (temp[1] = #24){ and (LastKey = ins)} then
	    begin
	      dir := DelLast(dir, 1);
	      dir := TruncateTo(dir, FindLastC(dir, '\'));
	    end
	   else if (temp[1] = #25) {and (LastKey = ins)} then
	    begin
	      dir := dir + DelFirst(temp, 1) +'\';
	    end;
	end;
    until (LastKey = Enter) or (lastKey = Esc);
  dir := dir + temp2;
   if lastKey = Esc then
    begin
      dir :=oldDir;
      startDir := oldStartDir;
      GetDir := dir;
    end;
end;

Procedure GetDirO.SetDir(startDir1, dir1 : DirStr);
begin
  dir := dir1;
  startDir := startDir1
end;

{Function GetDirO.SubDir: DirStr;
begin
  SubDir := dir;
end;}
{*****************************end GetDirO*************************}

{ Example for BlockRead and BlockWrite }

Procedure CopyFile(f1, f2: ComStr);
{ Simple copy program w/NO error checking }
var
  FromF, ToF: file;
  NumRead, NumWritten: Word;
  buf: array[1..2048] of Char;
begin
   if not test(f1) then
    begin
      Message(' Error ', 'File not found <'+f1+'>',
	     ErrorRec.EFlash, ErrorRec.EHz, ErrorRec.EDelay1, ErrorRec.EDelay2);
      exit;
    end;
   if test(f2) then
    begin
      Message(' Error ', 'destination file all ready egsists <'+f1+'>',
	     ErrorRec.EFlash, ErrorRec.EHz, ErrorRec.EDelay1, ErrorRec.EDelay2);
      exit;
    end;
  { Open input file }
  Assign(FromF, f1);
  { Record size = 1 }
  Reset(FromF, 1);
  { Open output file }
  Assign(ToF, f2);
  { Record size = 1 }
  Rewrite(ToF, 1);
  MakeWindow(0, 0, 40, 1, 0, 'Infomation');
  WriteLn('Copying ', FileSize(FromF), ' bytes...');
  repeat
    BlockRead(FromF,buf, SizeOf(buf),NumRead);
    BlockWrite(ToF,buf,NumRead,NumWritten);
  until (NumRead = 0) or
	(NumWritten <> NumRead);
  DelWindow(0, 0);
  Close(FromF);
  Close(ToF);
end;

Procedure ChDir(S : String);
var
  d : DirStr;
  t : Boolean;
begin
  t := False;
   if (length(s) > 2) or ((length(s) > 1) and (s[2] <> ':'))  then
   s :=  DelTrailing(s,'\ ');
  s :=  DelLeading(s, ' ');
   if (FileDrive(s) <> '') and (s[1] <> '\') then
    begin
      GetDir(0, d);
      t := True;
    end;
   if FileDrive(s) <> '' then s :=  DelLeading(s, '\ ');
  {$I-}
  System.ChDir(s);
   if IOResult <> 0 then WriteLn(#10#13'Cannot find directory');
   if t then System.ChDir(d);
  {$I+}
   if IOResult <> 0 then WriteLn(#10#13'Error Cannot find directory');
   if DosError <> 0 then DosE;
end;

Procedure WriteTime(x, y : Byte); Assembler;
var
  h, m, s, hund : Word;
  str, str2	: String;
asm
  mov	ax, seg h;		push	ax
  mov	ax, offset h;		push	ax
  mov	ax, seg m;		push	ax
  mov	ax, offset m;		push	ax
  mov	ax, seg s;		push	ax
  mov	ax, offset s;		push	ax
  mov	ax, seg hund;		push 	ax
  mov	ax, offset hund; 	push	ax
  call	GetTime
  push	x.word
  push	y.word
  mov	ax, seg str
  push	ax
  mov	ax, offset str
  push  ax
  push  h
  call	LeadingZero
  mov	ax, m
  call	@LZStr2
  call	LeadingZero
  call  @AddStr2ToStr1
  mov	ax, s
  call	@LZStr2
  call  @AddStr2ToStr1
  mov	ax, hund
  call	@LZStr2
  call  @AddStr2ToStr1
  mov	ax, 0
  push  ax
  mov	ax, seg str
  push  ax
  mov	ax, offset str
  push	ax
  call  DrectWriteS
  jmp	@end
@AddStr2ToStr1:
  mov	ax, seg str
  push	ax
  mov	ax, offset str
  push	ax
  mov	ax, seg str2
  push	ax
  mov	ax, offset str2
  push	ax
  call	AddTo
  ret
@LZStr2:
  mov	bx, seg str2
  push	bx
  mov	bx, offset str2
  push	bx
  push	ax
  call	LeadingZero
  ret
{  GetTime(h,m,s,hund);
  DrectWrite(x, y, LeadingZero(h)+':'+LeadingZero(m)+':'+LeadingZero(s)+
	  '.'+LeadingZero(hund));}
@end:
end;

Function FileDrive(s : ComStr) : S1;
begin
  s := DelLeading(s, '\ ');
  if (UpCase(s[1]) in ['A'..'Z']) and (s[2] = ':') then
   FileDrive := UpCase(s[1]) else
   FileDrive := '';
end;

Function GetFile(start : string) : ComStr;
var
  buff                           : bufferO;
  DirInfo                        : SearchRec;
  path                           : PathStr;
  x, poss,bufpos,temphi, temppos : Integer;
  k                              : string[2];

Procedure Shift(ss:LongInt);
var
  x : Byte;
  temp : string;
  bsize : Word;
begin
  temphi := 0;
  bsize := Buff.Len;
   if poss < 1 then begin poss:=1;bufpos:=1;ss:=0; end;
   if poss > bsize then if bsize > 9 then
    begin poss:=bsize; bufpos:=bsize-9; ss:=0; end else
    bufpos := bsize;
   if ss = 1 then
    begin
      GotoXY(1,10);
      bufpos := bufpos + ss;
      Write(PadTo(buff.Get(poss-1), ' ', 20));
      GotoXY(21,10);
      Write(#10#13);
      GotoXY(1,10);
      Exit;
    end;
   if (ss = -1) and (poss > 1) then
    begin
      bufpos := bufpos + ss;
      GotoXY(1,1);
      Write(PadTo(buff.Get(bufpos+1), ' ', 20));
      InsLine;
      Exit;
    end;
  ClrScr;
  bufpos :=bufpos + ss;
   for x := 1 to 10 do
    begin
      GoToXY(1, x);
      temp := buff.Get(bufpos+x-1);
      Write(temp);
    end;
end;
var
  dir  : DirStr;
  name : NameStr;
  ext  : ExtStr;
  sbo  : Boolean;
  errorE : Word;
Label Skip;
begin
  InOutZ;
  sbo := false;
  Skip:
  DelAllWindows;
  poss := 1;
  bufpos := 1;
  ClrScr;
    Repeat
      MakeWindow(4, 4, 40, 1, 0, '');
       if InOutError then InOut(errorE, 9, 271);
{      WindoWE(4,4,40,1,White);}
      TextBackground(White);
      TextColor(Black);
      GetDir(0,dir);
       if sbo = True then else
      path := ConCat(dir,'\',start);
      Write(path);
      TextBackground(Black);
      TextColor(White);
      k := KeyLoop;
       if (k>=' ') and (k<='~') then
        begin
          ClrScr;
	  path := ReadLine(k, 79);
	end else
       if k <> ret then
        begin
          ClrScr;
	  path := ReadLine(path, 79);
        end;
      {$I-}
      FindFirst(path, Archive, DirInfo);
       if IOResult <> 0 then Write('IOResult ', IOResult);
      {$I+}
      DelAllWindows;
    until(IOResult = 0);
   sbo := True;
   if TFile(path) then
    begin
      Path := SUpCase(path);
      GetFile := Path;
      Exit;
    end;
  buff.Clr;
   while DosError = 0 do
    begin
      buff.Add(Concat(padto(DirInfo.Name, ' ', 14),IntToStr(DirInfo.Size)));
      FindNext(DirInfo);
    end;
    GotoXY(10,25);
    Write('Press F4 to enter new mask');
  MakeWindow(4, 4, 40, 1, 0, '');
   if InOutError then InOut(errorE, 10, 314);
{  windoWE(4,7,21,10,White);}
  shift(0);
    Repeat
       if temphi <> 0 then
        begin
          GotoXY(1,temphi);
	  Write(PadTo(buff.Get(temppos), ' ', 20));
        end;
      GotoXY(1,poss - bufpos+1);
      TextColor(Black);
      TextBackground(White);
      Write(PadTo(buff.Get(poss), ' ', 20));
      TextColor(White);
      TextBackground(Black);
      temphi := poss-bufpos+1;
      temppos := poss;
      k := keyLoop;
       if k = up then
        poss:=poss-1 else
       if k = down then poss:=poss+1 else
       if k = pgup then poss:=poss-10 else
       if k = f4   then Goto Skip;
       if k = pgdn then poss := poss+10;
       if poss >= bufpos+10 then
        shift(poss-bufpos-9);
       if poss < bufpos then
        shift(poss-bufpos);
    until((k = Esc) or (k = ret));
  FSplit(path,dir,name,ext);
  path := ConCat(dir,Copy(buff.Get(poss),1,14) );
  path := SupCase(path);
   if k = ret then GetFile := path else
   GetFile := '';
  DelAllWindows; {CWindo;}
  buff.Done
end;

Function GetFileDir(s : String) : DirStr; {Prams must be removed}
begin
  s := DelAllK(s, ' ');
  GetFileDir := FileDir(s);
end;

Function GetFileExt(s : String) : ExtStr; {Prams must be removed}
begin
  s := DelAllK(s, ' ');
  GetFileExt := FileExt(s);
end;

Function GetFileName(s : String) : NameStr; {Prams must be removed}
begin
  s := DelAllK(s, ' ');
  GetFileName := FileName(s);
end;

Procedure JExec(in1, in2 : String);
Begin
  SwapVectors;
  Exec(in1, in2);
  SwapVectors;
  DosEC := DosExitCode;
   if DosError <> 0 then{ Error? }
    DosE
   else
     Message(' Message 8 ', Concat('Exec successful. Child process exit code = ', IntToStr(DosEC)),
       ErrorRec.MFlash, ErrorRec.MHz, ErrorRec.MDelay1, ErrorRec.MDelay2);
end;

Procedure CreateFile(f: Comstr);
var
  f2:		File;
  error:	word;
begin
  InoutZ;
   if TestDir(FileDir(f)) = false then
    if FileDir(f) <> '' then MDir(FileDir(f));
   if Test(f) = False then
    begin
{$I-}
      Assign(f2, f);
      Rewrite(f2);
      Close(f2);
{$I+}
      Error := IOResult;
       if error > 0 then Inout(Error, 9, 442);
    end;
end;


Procedure Open(f : ComStr);
var
  f2 : File;
begin
   if FileName(f) = '' then exit;
   if not FileExists(f) then
   if ReadYN('Information', f+' not found Rewrite', False, True) then
    begin
      Assign(f2, f);
      Rewrite(f2);
      Close(f2);
    end;
end;

Function GetFileDirNameExt(s : String): String;
begin
  GetFileDirNameExt := FileDir(s)+FileName(s)+FileExt(s);
end;


Function TestFile(s : ComStr): ComStr;
var
  D: DirStr;
  N: NameStr;
  E: ExtStr;
begin
  FSplit(s, D, N, E);
   if FileExists(jmcdir + n + e) then TestFile := jmcdir + n + e else
   if FileExists(s) then TestFile := s else
   if FileExists(FExpand(FSearch(n+e, GetEnv('PATH')))) then
      TestFile := FExpand(FSearch(n+e, GetEnv('PATH'))) else
  TestFile := s;
end;



Function TFile(s : ComStr) : Boolean;
Var
  Dir  : DirStr;
  name : NameStr;
  ext  : ExtStr;
  x    : Byte;
begin
  Tfile := True;
  FSplit(s,dir,name,ext);
   s := ConCat(name,ext);
   s := SUpCase(s);
    for x := 1 to Length(s) do if (s[x]='*')or(s[x]='?') then TFile := False;
end;

Function TOpen(f : String): Boolean;
    var
      f2     : file;
      cmd1   : string;
begin
  ClrScr;
  WriteLn(f ,' file not found crate new y /n');
  cmd1 := ReadKey;
  if SUpCase(cmd1) = SUpCase('y') then
    begin
      TOpen := True;
      Assign(f2, f);
      Rewrite(f2);
      Close(f2);
      Topen := True;
    end else
    begin
      Topen := False;
      Exit;
    end;
end;

Function ParamFile : ComStr;
var
 pstr : ComStr;
 boo  : BooLean;
begin
  boo := True;
   if ParamCount < 1 then begin ParamFile:=''; Exit; end;
  pstr := ParamStr(1);
   if Test(pstr) = False then boo := TOpen(pstr);
   if boo = False then pstr := '';
  ParamFile := pstr;
end;

Function Vol(s : String) : S12;
var
  DirInfo: SearchRec;
begin
  s := DelLeading(s, ' ');
   if Length(s) > 2 then s[0] := #2;
   if (s[2] = ':') and (InString('ABCDEFGHIJKLMNOPQRSTUVWXYZ', UpCase(s[1]))) then else
   s := '';
  FindFirst(s+'*.*', VolumeID, DirInfo);
  DosE;
   if Length(DirInfo.Name) > 8 then Delete(DirInfo.Name, 9, 1);
  vol := DirInfo.Name;
end;

Procedure DelFile(f :String);
var
  f2:	file;
begin
  ClrScreen(0);
  GotoXY(1,1);
  Assign(f2, f);
  {$I-}
  Reset(f2);
  {$I+}
   if IOResult <> 0 then
    begin
      WriteLn('Cannot find ', f);
      Delay(3000);
    end else
    begin
      Close(f2);
      WriteLn('Deleting ', f);
      Delay(3000);
      Erase(f2);
    end;
  ClrScreen(0);
  GotoXY(1,1);
end;

END.

