{$A+,B-,D+,E+,F+,G-,I+,L+,N+,O-,R+,S+,V+,X-}
{$M 16384,0,655360}

Unit _HyperText;

Interface

Uses _Buffers, dos, _Screen;
Const
  columns:		Byte = 1;
  endOfFileChar:	Char = ''; {#174}
  WordBufferAttr:	Byte = YellowC+BlueB;
Type
  ListBufO = Object
	       Constructor Init;
	       Destructor Done;

	       Procedure WriteBuffer(var buf : BufferO; colWidth, shift : Byte; startPos : Word);
	       Function ListBuffer(
				 var
				   buf : BufferO;
				   caseS : Boolean) : String; Virtual;
	     end;


IMPLEMENTATION

Uses Crt, _EditLine, _KeyB, _Dos, _Error, _String, _Win2, _Menus, _Code;

Procedure UpDateScreenShift(var screenShift : Word;pos, depth, columns : Word); ForWard;

var
  iTX, iTY:	Word;
  tempP:	Procedure;
  oldLL:	Word;
  lineInfo:	String[20];
{$F+}
Procedure WriteInfoP; {Assenbler;}
begin
  lineInfo := IntToStr(_EditLine.editFilePos)
	      +':'+IntToStr(_EditLine.linePos)
	      +':'+IntToStr(_EditLine.fileLength);
   if Length(lineInfo) < oldLL then lineInfo := PadTo(lineInfo, ' ', oldLL);
  DrectWriteS(iTX, iTY, 0, lineInfo);
  oldLL := Length(lineInfo);
  tempP
end;

{***************************Begin ListBufO****************************}
Procedure FNothing(var buf: BufferO;n : Word);
begin
end;
{$F-}


Constructor ListBufO.Init;
begin
end;

Destructor ListBufO.Done;
begin
end;

Function ListBufO.ListBuffer(var buf : BufferO; caseS : Boolean): String;
var
  x, screenShift, oldScrShift, lineShift, pos	: Word;
  Longst, maxLength, linePos, n, OldLineShift	: Word;
  cursorX, cursorY, cursorXOld, cursorYOld	: Byte;
  wW, wD					: Byte;
  k						: key;
begin
  linePos := 1;
  lineShift := 0;
  OldLineShift := 1;
  cursorX := 1;
  cursorY := 1;
  screenShift := 0;
  OldScrShift := 1;
  pos := 1;
  InOutZ;
  wW := WindWidth(0,0);
  wD := WindDepth(0,0);
   if wW < 1 Then InOut(531, 10, 84);
   if wD < 1 then InOut(532, 10, 85);
  Longst := 0;
   for x := 1 to buf.Len do if Length(buf.Get(x)) > Longst then Longst := Length(buf.Get(x));
  maxLength := Longst;
   if maxLength > wW then maxLength := wW;
    repeat
      cursorXOld := cursorX;
      cursorYOld := cursorY;
      cursorY := pos - screenShift;
      cursorX := 1;
       while cursorY > wD do
	begin
	  cursorY := cursorY - wD;
	  Inc(cursorX);
	end;
       cursorX := cursorX + ((cursorX - 1) * (maxLength));
       if (OldScrShift <> screenShift) or (OldLineShift <> lineShift) then
	begin
	  WriteBuffer(buf, maxLength + 1, lineShift, screenShift + 1);
	  OldScrShift := screenShift;
	  oldLineShift := lineShift;
	end
       else Bar(cursorXOld, cursorYOld, maxLength);
       Bar(cursorX, cursorY, maxLength);
       GotoXY(cursorX + (linePos - 1) - lineShift , cursorY);
      k := KeyLoop;
       if k = Left then
        begin
          linePos := 1;
           if pos > 1 then
            begin
	       if pos < wD then pos := 1
	       else pos := pos - wD;
	       if LongInt(screenShift) - wD < 0 then
	       screenShift := 0
	       else screenShift := screenShift - wD;
	      UpDateScreenShift(screenShift, pos, wD, Columns);
	    end;
        end
       else if k = Right then
        begin
          linePos := 1;
           if pos < buf.len then
            begin
	       if buf.len - pos   < wD then pos := buf.Len
	       else pos := pos + wD;
{?	      screenShift := screenShift + wD;}
	      UpDateScreenShift(screenShift, pos, wD, Columns);
	    end;
        end
       else if k = up then
        begin
          linePos := 1;
           if pos > 1 then Dec(pos);
           if screenShift >= pos then Dec(screenShift);
        end
       else if k = Down then
        begin
          linePos := 1;
           if pos < Buf.len then Inc(pos);
	   if screenShift + (Columns * wD) <= pos then Inc(screenShift);
	end
       else if k = PgDn then
        begin
	  linePos := 1;
	   if pos < buf.Len then
	    begin
	       if pos + (wD * Columns - 1) <= buf.Len then
		begin
		  pos := Pos + (wD * Columns - 1);
		  screenShift := screenShift + (wD * Columns - 1);
		end
		else pos := buf.Len;
	      UpDateScreenShift(screenShift, pos, wD, Columns);
	    end;
	end
       else if k = PgUp then
        begin
	  linePos := 1;
	   if pos > 1 then
	    begin
	       if Longint(pos) - (wD * Columns - 1) >= 1 then
		begin
		  pos := LongInt(pos) - (wD * Columns - 1);
		   if LongInt(screenShift) - (wD * Columns - 1) < 0 then
		   screenShift := 0
		   else screenShift := LongInt(screenShift) - (wD * Columns - 1);
		end
		else pos := 1;
	      UpDateScreenShift(screenShift, pos, wD, Columns);
	    end;
	end
       else if k = Home then
        begin
          pos := 1;
          linePos := 1;
          screenShift := 0;
        end
       else if k = End1 then
        begin
          linePos := 1;
	  pos := buf.Len;
	  UpDateScreenShift(screenShift, pos, wD, Columns);
	end
       else if k = CLeft then
        begin
           if linePos > 1 then Dec(linePos);
        end
       else if k = CRight then
        begin
           if linePos < Length(buf.Get(pos)) then Inc(linePos);
	end
       else if (k = Enter) or (k = Esc) then
       else begin
	 n := buf.find(TruncateTo(buf.Get(pos), linePos - 1)+k[1], linePos, CaseS);
	  if n <> 0 then
	   begin
	     Inc(linePos);
	     pos := n;
	     UpDateScreenShift(screenShift, pos, wD, Columns);
	   end;
       end;
    Until (k = Enter) or (k = Esc);
   if k = Enter then ListBuffer := buf.Get(pos)
   else ListBuffer := '';
end;

Procedure ListBufO.WriteBuffer(var buf : BufferO; colWidth, shift : Byte; startPos : Word);
Var
  x, y, wW, wD	: Byte;
  t 		: Word;
begin
  wW := WindWidth(0,0);
  wD := WindDepth(0,0);
   if colWidth < 1 then colWidth := 1;
   if colWidth > wW then colWidth := wW;
  columns := Trunc(wW / colWidth);
   ClrScr;
   for y := 1 to columns do
    begin
      t := (wD * (y - 1)) + (startPos - 1);
       for x := 1 to wD do
	begin
	   if x + t > buf.Len then Exit;
	  GotoXY(1 + ((y - 1) * (colWidth)), x);
	  Write(copy(buf.Get(x + t ), shift, colWidth) );
	end;
    end;
end;
{***************************End ListBufO****************************}

(*Procedure UpDateScreenShift(var screenShift : Word;pos, depth, columns : Word);
begin
  if screenShift < LongInt(pos) - (columns * WindDepth(0,0)) then
  screenShift := LongInt(pos) - (columns * WindDepth(0,0));
  if screenShift >= pos then screenShift := pos - 1;
end;*)

Begin
END.