{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,R+,S+,V+,X-}
{$M 16384,0,655360}


program keyrate;

uses Dos;

var
  Int1BSave : Pointer;


{$F+}
procedure nop; interrupt;
  begin
  end;
{$F-}


begin

  GetIntVec($9,Int1BSave);
  SetIntVec($9,Addr(nop));



 asm
   in	al, 64h

   cli
   mov	al, 60h		{tell Keybord to expect commant}
   out	064h, al

   call	@testW
   mov	al, 0f3h	{tell keyborad to expect delay repeat byte}
   out	60h, al

   mov	cl, 1
   call	@testR
@L5:
   in	al, 60h		{expect ACK}
   cmp	al, 0AFh
   mov	cl,3
   jne	@l5


   call	@testW
   mov	al, 00000000b   {send delay repeat byte}
   out	60h, al

   mov	cl, 2
   call	@testR
@L6:
   in	al, 60h		{expect ACK}
   cmp	al, 0AFh
   mov	cl, 6
   jne	@L6

   jmp	@end

@testR:
	mov	si, 010h
@testR_L1:
	mov	bx, 0FFFFh
@testR_L2:
	in	al, 64h
	and	al, 00000001b
	cmp	al, 1b
	je	@testR_XL
	sub	bx, 1
	cmp	bx, 0
	jne	@testR_L2
	sub	si, 1
	cmp	si, 0
	jne	@testR_L1
	mov	ch, 0Fh
{	add	sp, 4
	jmp	@Error}

@testR_XL:
	ret

@testW:
	mov	cx, 0FFFFh
@testW_L3:
	in	al, 64h
	and	al, 00000010b
	cmp	al, 0b
	je	@testW_XL2
	sub	cx, 1
	cmp	cx, 0
	jne	@testW_L3
	mov	ch, 0Eh
	add	sp, 4
	jmp	@Error

@testW_XL2:
	ret


@Error:
	sti

	or	al,al
@end:

	sti

{   mov	ah, 3
   mov	al, 5
   mov	bh, 0h
   mov	bl, 0h
   int	16}

 end;
 SetIntVec($9,Int1BSave);

end.