unit ConstDef;

interface
Uses _PasWord, Windows, _Dos, _buffers, _JWin, Dialogs;

Const
  minD		= 500;		// min time to display word
  letD		= 75;		// add this much for each letter
  d 		= 2;
  pauseD	= 1500;		// Wait this long before allowed to enter word

Var
  ProgramDir:   String;
  pasFile:      String = 'JSYS1.JSY';
  UserSubDir:	String = 'User\';
  RootDir:	String;
  SubDir:	String = '';
  CurrentFile:	String = 'words0.spl';
  WavPath:	String = 'c:\';
//  StartUpFile:	String;
  DefaultDB:    String;
    // reg keys
	//scoreDB = the name of the datadase used
  inOrder:	Boolean = False;	//Sort the questions in order(else the questions soted random order)
  doFile:	Boolean = True;		//Do the whole file (else do 10 questions)
  ReshowIfWave:	Boolean = False;
  ShowIfWave:	Boolean = True;
  noSortOverride:	Boolean = False;//Overrride sorting the questions in any order so they are in file order (except expanded script)
//  NotInOrderOverride:   Boolean = False;
  interbaseRoot:String;
  optionMenuPasLev:  Integer = 10;
  soundMenuPasLev:  Integer = 0;
  listSoundsPasLev: Integer = 0;
  soundDelPasLev:   Integer = 250;
  ChangeDBPasLev:   Integer = 250;
  delFilePasLev:    Integer = 100;
  lookOtherUsersPasLev:	Integer = 200;
  MakeWrongWordFileForOthers:	Integer = 210;

  closeButton: Boolean = False;


  Pas:		PasswordO;
  DefaultUser:	String = 'User';
  LogMistakes:	Boolean = True;		//see below
  LogAll:	Boolean = True;		//see below

//Registry strings
  regKeyOffset: String = '\Software\Joseph M. N. Chamness\Spl\7.0\Data';

  //reg keys
  dbKey: String = 'scoreDB';
  pasFileKey: String = 'pasFile';//key for password file name.


  //registry keys under HKEY_LOCAL_MACHINE used to locate the database home dir
  FirebirdOffset	:String = 'Software\Firebird Project\Firebird Server\Instances';
  FirebirdKey		:String = 'DefaultInstance';
  InterbaseOffset	:String = 'Software\Borland\InterBase\CurrentVersion';
  InterbaseKey 		:String = 'RootDirectory';

implementation
uses
  _RegKey;
var
//  buf:BufferO;
  temp:String;
begin
//  buf.Init;
  ProgramDir	:= FilePath(ParamStr(0));
  RootDir	:= ProgramDir + 'spl.spl\';
  DefaultDB     := ProgramDir + 'scoredb.gdb';

  if RegKeyExists(regKeyOffset,pasFileKey) then
   pasFile := getRegkey(regKeyOffset,pasFileKey);
  pas := PasswordO.Create(ProgramDir, Pasfile);

  //  StartUpFile := ProgramDir+'StartVals';
//  interbaseRoot := getRegkey(FirebirdOffset,FirebirdKey);
  if RegKeyExists(FirebirdOffset,FirebirdKey) then interbaseRoot := getRegkey(FirebirdOffset,FirebirdKey)
  else if RegKeyExists(InterbaseOffset, 'RootDirectory') then interbaseRoot := getRegkey(InterbaseOffset, 'RootDirectory')
  else begin
    MessageDlg('Can''t locate any compatible database keys in the registry, you probably need to install Firebird or InterBase',
      mtWarning, [mbOk], 0, );
    MessageDlg('Can''t continue with out a compatible database. Spl will now terminate',
      mtInformation, [mbOk], 0, );
    ExitProcess(800);
//    interbaseRoot := '';
  end;
  if test(ProgramDir+'sql_dll.dll') = True then
  begin
    if (interbaseRoot <> '') and (testDir(interbaseRoot)) then
      if not test(interbaseRoot+'UDF\sql_dll.dll') then
      begin
	temp := JCopyFile(ProgramDir+'sql_dll.dll', interbaseRoot+'UDF\sql_dll.dll', True);
      end
  end;
  if not test(interbaseRoot+'UDF\sql_dll.dll') then
    MessageDlg('Can not copy the database .dll file OUCH!! :'#10#13+temp,
      mtWarning, [mbOk], 0);
  LogMistakes := GetRegKeyBool2(regKeyOffset, 'LogMistakes');
  LogAll := GetRegKeyBool2(regKeyOffset, 'LogAll');
end.
