{$A+,B-,C-,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q+,R+,S-,T-,U-,V+,W+,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
unit Spl6;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ExtCtrls, _Dos, Buttons, ComCtrls, ToolWin, Printers,
  AppEvnts, ImgList, _about,_ScoreUtils2, OleCtrls, SHDocVw{, HH, HH_FUNCS};



type
  TMainForm = class(TForm)
    Label1: TLabel;
    MainMenu1: TMainMenu;
    Help1: TMenuItem;
    About1: TMenuItem;
    HowtoUseHelp1: TMenuItem;
    SearchforHelpOn1: TMenuItem;
    Contents1: TMenuItem;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    PrintSetup1: TMenuItem;
    Print1: TMenuItem;
    N2: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    User1: TMenuItem;
    AddUser1: TMenuItem;
    Editusers1: TMenuItem;
    LogOutButton: TButton;
    Option1: TMenuItem;
    Option2: TMenuItem;
    OpenDialog1: TOpenDialog;
    CFile: TLabel;
    Edit1: TMenuItem;
    EditFile1: TMenuItem;
    Log1: TMenuItem;
    LogWords1: TMenuItem;
    Score1: TMenuItem;
    N3: TMenuItem;
    UserLabel: TLabel;
    Label2: TLabel;
    ChangePasword1: TMenuItem;
    ChaDir1: TMenuItem;
    Label3: TLabel;
    DirLabel: TLabel;
    dirL: TLabel;
    Image1: TImage;
    Label4: TLabel;
    FileLengthLabel: TLabel;
    PrinterSetupDialog1: TPrinterSetupDialog;
    PrintDialog1: TPrintDialog;
    StatusBar1: TStatusBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ImageList1: TImageList;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ApplicationEvents1: TApplicationEvents;
    NewDir1: TMenuItem;
    BStart: TBitBtn;
    BitBtn2: TBitBtn;
    ToolButton9: TToolButton;
    Viewwords1: TMenuItem;
    ToolButton10: TToolButton;
    Logusers1: TMenuItem;
    N4: TMenuItem;
    Deletefile1: TMenuItem;
    ToolButton11: TToolButton;
    Logall1: TMenuItem;
    Sound1: TMenuItem;
    Words1: TMenuItem;
    View1: TMenuItem;
    Loglist1: TMenuItem;
    Removedir1: TMenuItem;
    Image2: TImage;
    Changedatabase1: TMenuItem;
    ViewCompiled1: TMenuItem;
    Makewrongwordfile1: TMenuItem;
    N5: TMenuItem;

    procedure LogOutButtonClick(Sender: TObject);
    procedure Start(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ChangeLabel(s: string);
    procedure Open1Click(Sender: TObject);
    procedure Option2Click(Sender: TObject);
    procedure QuitButtonClick(Sender: TObject);
    procedure Score1Click(Sender: TObject);
    procedure ChangePasword1Click(Sender: TObject);
    procedure Editusers1Click(Sender: TObject);
    procedure AddUser1Click(Sender: TObject);
    procedure EditFile1Click(Sender: TObject);
    procedure ChaDir1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PrintSetup1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure ApplicationEvents1Hint(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure NewDir1Click(Sender: TObject);
    procedure Viewwords1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure LogWords1Click(Sender: TObject);
    procedure Logall1Click(Sender: TObject);
    procedure Words1Click(Sender: TObject);
    procedure View1Click(Sender: TObject);
    procedure Removedir1Click(Sender: TObject);
    procedure Deletefile1Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Changedatabase1Click(Sender: TObject);
    procedure ViewCompiled1Click(Sender: TObject);
    procedure Makewrongwordfile1Click(Sender: TObject);
    procedure Contents1Click(Sender: TObject);
    procedure HowtoUseHelp1Click(Sender: TObject);
    procedure SearchforHelpOn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);

  private
    { Private declarations }
//    procedure DisplayHint(Sender: TObject);
    procedure WMEndSession(var Message: TWMEndSession); message WM_ENDSESSION;
  public
    { Public declarations }
  end;


var
  MainForm: TMainForm;
//  mHHelp: THookHelpSystem;

implementation
uses _String, Option, _GetUser, _PasWord, input, ConstDef, _ScoreUtils, _LoadUser,
     _OpenFile, _LookAtPas, _Edit, _DirTree, _Buffers, soundDB, _Code,registry,
     Score2, SplCommon, _RegKey, _ViewConpiled, MakeWrongwordFile, HelpIntfs;


procedure SuperUser;		Forward;
procedure User;			Forward;
procedure NoUser;		Forward;

{$R *.DFM}

procedure UserLogin;
begin
  pas.TestPasWord;
   if pas.PasLevel = 255 then SuperUser
   else if pas.PasLevel >= 0 then User;
end;

procedure SuperUser;
begin
  MainForm.UserLabel.Caption := constDef.pas.User;
  MainForm.File1.Enabled := True;
  MainForm.Option1.Enabled := True;
  MainForm.User1.Enabled := true;
  MainForm.BStart.Enabled := True;
  MainForm.Log1.Enabled := True;
  LoadUserDefaults;
  MainForm.CFile.Caption := {subDir+}CurrentFile;
  Mainform.FileLengthLabel.Caption := IntToStr(FileSizeText(rootDir+subDir+CurrentFile));
  MainForm.Exit1.Enabled := True;
  MainForm.dirL.Caption := SubDir;
  MainForm.Sound1.Enabled := True;
end;

procedure User;
begin
  MainForm.UserLabel.Caption := constDef.pas.User;;
  MainForm.File1.Enabled := True;
  MainForm.BStart.Enabled := True;
   if pas.PasLevel >= optionMenuPasLev then MainForm.Option1.Enabled := True
   else MainForm.Option1.Enabled := False;
  MainForm.User1.Enabled := True;
  MainForm.Exit1.Enabled := True;
  LoadUserDefaults;
   if pas.PasLevel >= soundMenuPasLev then MainForm.Sound1.Enabled := True
   else MainForm.Sound1.Enabled := False;
  MainForm.CFile.Caption := {subDir+}CurrentFile;
  Mainform.FileLengthLabel.Caption := IntToStr(FileSizeText(rootDir+subDir+CurrentFile));
  MainForm.dirL.Caption := SubDir;
end;

Procedure LogOut;
begin
  SaveUserDefaults;
  pas.LogOut;
  NoUser;
end;


procedure NoUser;
begin
  pas.LogOut;
  MainForm.UserLabel.Caption := 'no user';
  MainForm.File1.Enabled := False;
  MainForm.Option1.Enabled := False;
  MainForm.User1.Enabled := False;
  MainForm.BStart.Enabled := False;
  MainForm.Log1.Enabled := False;
  MainForm.Exit1.Enabled := False;
  MainForm.dirL.Caption := 'no user';
  MainForm.Sound1.Enabled := False;
//  _pasWord := DefaultUser;
end;

Function GetOwnerOf(f: ComStr): String;
var
 temp	:String;
begin
  temp := ReadTextFileLine(FileDir(f)+FileName(f)+'.USR', 1);
   if temp = '' then temp := '(Owner not found)';
  GetOwnerOf := temp;
end;

procedure TMainForm.LogOutButtonClick(Sender: TObject);
begin
  LogOut;
  UserLogin;
  if BStart.Enabled then  BStart.SetFocus
  else if LogOutButton.Enabled then LogOutButton.SetFocus;
end;

procedure TMainForm.Start(Sender: TObject);
begin
  CFile.Caption := CurrentFile;
  Mainform.FileLengthLabel.Caption := LengthOfFile_Spl;
  input.Mane2(RootDir+SubDir+CurrentFile, constDef.pas.User);
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
//   if SoundsForm.WavForWord('_Start_up') then
//    SoundsForm.PlayWord('_Start_up');
  LogWords1.Checked := LogMistakes;
  NoUser;
  UserLogin;
  if MainForm.BStart.Enabled then BStart.SetFocus;
end;

procedure TMainForm.ChangeLabel(s: string);
begin
  Cfile.Caption := s;
  Mainform.FileLengthLabel.Caption := '?';//FileSizeText(rootDir+subDir+CurrentFile);
end;

procedure TMainForm.Open1Click(Sender: TObject);
begin
  OpenSplFile;
  CFile.Caption := {SubDir+}CurrentFile;
  Mainform.FileLengthLabel.Caption := IntToStr(FileSizeText(rootDir+subDir+CurrentFile));
  dirL.Caption := SubDir;
end;

procedure TMainForm.Option2Click(Sender: TObject);
begin
  OptionForm.ShowModal;
end;

procedure TMainForm.QuitButtonClick(Sender: TObject);
begin
   if pas.IsUserLoggedOn then Logout;
   closeButton := True;
  Application.Terminate;
end;

procedure TMainForm.Score1Click(Sender: TObject);
begin
  sf2.ShowModal;
end;

procedure TMainForm.ChangePasword1Click(Sender: TObject);
begin
  pas.ChangePasword;
end;

procedure TMainForm.Editusers1Click(Sender: TObject);
begin
  LookAtPas;
end;

procedure TMainForm.AddUser1Click(Sender: TObject);
begin
  pas.AddPasWord;
end;

procedure TMainForm.EditFile1Click(Sender: TObject);
begin
  EditSpl.Edit(RootDir + SubDir + CurrentFile);
end;

procedure TMainForm.ChaDir1Click(Sender: TObject);
begin
  ChDir.loadTree(RootDir, SubDir, 'Change Diretory' );
  SubDir := DelTrailing(SubDir, '\')+'\';
  CurrentFile := 'words0.spl';  
  CFile.Caption := SubDir+CurrentFile;
  dirL.Caption := SubDir
end;

procedure TMainForm.New1Click(Sender: TObject);
var
  s:	string;
  buf:BufferO;
begin
  s := InputBox('New File', 'Input a file name', '');
  s := fileName(s);
   if s = '' then exit;
   if test(RootDir+SubDir+s+'.Spl') then
    MessageDlg('File already exists', mtWarning, [mbOk],0)
   else if MessageDlg('Create new file: ' + SubDir+s,
	mtConfirmation, [mbYes, mbNo],0) = mrYes then
    begin
       if TestOpen(RootDir+SubDir+s+'.Spl') then
	begin
	  buf := bufferO.Create;;
	  buf.add('"'+pas.User+'"');
	  SaveBuffer(buf,RootDir+SubDir+s+'.usr');
	  buf.Destroy;
	  CurrentFile := s+'.Spl';
	  MainForm.CFile.Caption := subDir+CurrentFile;
	  Mainform.FileLengthLabel.Caption := IntToStr(FileSizeText(rootDir+subDir+CurrentFile));
	end;
    end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  LogOut;
end;

procedure TMainForm.PrintSetup1Click(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;

procedure TMainForm.Print1Click(Sender: TObject);
var
  PageNum:	String;
  Ctr, x, PHeight, LineSpace, LinesPerPage, FontSize: Integer;
  buf:BufferO;
begin
x:=0;
   if PrintDialog1.Execute then
    begin
      Ctr := 1;
      Printer.Title := CurrentFile;
      Printer.BeginDoc;
      PHeight := Printer.PageHeight;
      Printer.Canvas.Font.Size := 18;
      Printer.Canvas.Font.Name := 'Times New Roman';
      FontSize := Printer.Canvas.TextHeight('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1');
      LinesPerPage := PHeight Div (FontSize +10);
      LineSpace := PHeight Div LinesPerPage;
      PageNum := IntToStr(Printer.PageNumber);
      buf := bufferO.Create;;
      LoadBuffer(buf, RootDir+SubDir+CurrentFile);
       while Ctr <= buf.Len do
	begin
	  Printer.Canvas.TextOut(0, x, buf.Get(Ctr));
	  x := x + LineSpace;
	  Inc(Ctr);
	   if Ctr > LinesPerPage - 1 then
	    begin
	      Printer.NewPage;
	      x:=0;
	      Ctr:=0;
	      PageNum := IntToStr(Printer.PageNumber);
//	      lable1.caption := 'Now printing ';
	    end;
	end;
      buf.Destroy;
      Printer.EndDoc;
    end;
end;
{$d-}
procedure TMainForm.ApplicationEvents1Hint(Sender: TObject);
begin
  StatusBar1.SimpleText := GetLongHint(Application.Hint);
end;
{$d+}

procedure TMainForm.About1Click(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TMainForm.NewDir1Click(Sender: TObject);
begin
  ChDir.MakeDir;
end;

procedure TMainForm.Viewwords1Click(Sender: TObject);
begin
  EditSpl.View(RootDir + SubDir + CurrentFile);
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
     if closeButton then
    begin
      if su.IBTransaction1.InTransaction then
        su.IBTransaction1.Rollback;
      CanClose := true;
      closeButton := false;
    end
    else begin
      CanClose := False;
      MessageDlg('Please use Quit button', mtWarning, [mbOk],0);
    end;
end;

procedure TMainForm.LogWords1Click(Sender: TObject);
begin
  LogWords1.Checked := not LogWords1.Checked;
  LogMistakes := LogWords1.Checked;
  WriteKeyBool(regKeyOffset, 'LogMistakes',LogWords1.Checked);
end;

procedure TMainForm.Logall1Click(Sender: TObject);
begin
  LogAll1.Checked := not LogAll1.Checked;
  LogAll := LogAll1.Checked;
  WriteKeyBool(regKeyOffset, 'LogAll', LogAll1.Checked);
end;

procedure TMainForm.Words1Click(Sender: TObject);
begin
  SoundsForm.ShowModal;
end;

procedure TMainForm.View1Click(Sender: TObject);
begin
  if not pas.IsUserLoggedOn then
    begin
      ShowMessage('No valid user name');
      exit;
    end;
  if pas.TestPasLevel(IntToStr(lookOtherUsersPasLev)) then
    begin
      su.PickFromList.Enabled := True;
      su.ShowAllUser.Enabled  := True;
      su.PickFromList.Enabled := True;
      su.SQL.ReadOnly := False;
    end
    else begin
      su.PickFromList.Enabled := False;
      su.ShowAllUser.Enabled  := False;
      su.PickFromList.Enabled := False;
      su.SQL.ReadOnly := True;
    end;
  su.ShowCurrentUser.Checked := true;
  su.ShowModal;
end;

procedure TMainForm.Removedir1Click(Sender: TObject);
var
  dir: String;
  mrResult: Word;
begin
  dir := SubDir;
  mrResult := ChDir.LoadTree(RootDir, dir, 'Directory to remove');
  if mrResult = mrOk then
    begin
      mrResult := _Dos.RemoveDir(RootDir+dir);
      if mrResult <> 0 then
	MessageDlg(ErrorCode(mrResult), mtError, [mbOK], 0);
    end;
end;

procedure TMainForm.Deletefile1Click(Sender: TObject);
var
  s, f:	String;
  error:	Word;
begin
  f := rootDir+subDir+CurrentFile;
  s := IntToStr(200);
  s := s+ ' ' +  GetOwnerOf(f);
  if pas.TestPasLevel(s) = False then
    begin
      MessageDlg('Access denied this is not your file! <'+subDir+CurrentFile+'>.'+
	      #10'The owner is :'+GetOwnerOf(f), mtWarning, [mbOK], 0)
    end
    else begin
      if MessageDlg('Are you sure you want to delete <'+
	     subDir+CurrentFile+'>.'
	     , mtConfirmation, [mbYes, mbNo], 0) = mrYes then
	begin
	  error := DeleteFile(f);
	  if error <> 0 then MessageDlg(ErrorCode(error), mtError, [mbOK], 0);
          error := DeleteFile(ChangeFileExt(f,'.usr'));
	  if error <> 0 then MessageDlg(ErrorCode(error), mtError, [mbOK], 0);
	end;
    end;
end;

procedure TMainForm.WMEndSession(var Message: TWMEndSession);
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    if Reg.OpenKey('\Software\Microsoft\Windows\CurrentVersion\RunOnce', True)
    then
      begin
	Reg.WriteString('MyApp','"' + ParamStr(0) + '"');
	closeButton := True;
      end;
  finally
    Reg.CloseKey;
    Reg.Free;
    inherited;
  end;
end;


procedure TMainForm.Image1Click(Sender: TObject);
begin
   if (SoundsForm.WavForWord('_Tish')) and (pas.User = 'Letitia') then
    SoundsForm.PlayWord('_Tish');
end;

procedure TMainForm.Changedatabase1Click(Sender: TObject);
begin
  su.changeDB;
end;

procedure TMainForm.ViewCompiled1Click(Sender: TObject);
begin
  CompiledView.View(RootDir + SubDir + CurrentFile);
end;

procedure TMainForm.Makewrongwordfile1Click(Sender: TObject);
begin
  if not pas.IsUserLoggedOn then
    begin
      ShowMessage('No valid user name');
      exit;
    end;
  if pas.TestPasLevel(IntToStr(MakeWrongWordFileForOthers)) then
    begin
      su1.PickFromList.Enabled := True;
      su1.ShowAllUser.Enabled  := True;
      su1.PickFromList.Enabled := True;
      su1.SQL.ReadOnly := False;
    end
    else begin
      su1.PickFromList.Enabled := False;
      su1.ShowAllUser.Enabled  := False;
      su1.PickFromList.Enabled := False;
      su1.SQL.ReadOnly := True;
    end;
  su1.ShowCurrentUser.Checked := true;
  su1.ShowModal;
end;

procedure TMainForm.Contents1Click(Sender: TObject);
begin
  Application.HelpCommand(3, 0);
//  Application.HelpCommand(HELP_CONTEXT, 3);
//  Application.HelpSystem.ShowTableOfContents;
 // Application.HelpSystem.ShowTopicHelp('Main Window','');
//  Application.HelpSystem
//  Application.
end;

procedure TMainForm.HowtoUseHelp1Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_HELPONHELP, 0);
end;

procedure TMainForm.SearchforHelpOn1Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_KEY, 3);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
//  mHHelp := THookHelpSystem.Create('C:\Program Files\Joseph M. N. Chamness\Spl\help\spl7.chm', '', htHHAPI);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
//  mHHelp.Free;
//  HHCloseAll;     //Close help before shutdown or big trouble
end;

end.
